package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BitmapTransform {

public final static byte Identity = 0;
public final static byte FlipY = 1;
public final static byte FlipX = 2;
public final static byte FlipDiag = 4;
public final static byte ScaleHalf = 8;


/* One dimension array */
public static BitmapTransform[] InstArrayBitmapTransform(int size) {
	BitmapTransform[] newArray = new BitmapTransform[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BitmapTransform();
	return newArray; }

/* Two dimension array */
public static BitmapTransform[][] InstArrayBitmapTransform(int size1, int size2) {
	BitmapTransform[][] newArray = new BitmapTransform[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapTransform[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BitmapTransform(); }
	return newArray; }

/* Three dimension array */
public static BitmapTransform[][][] InstArrayBitmapTransform(int size1, int size2, int size3) {
	BitmapTransform[][][] newArray = new BitmapTransform[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapTransform[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BitmapTransform[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BitmapTransform(); } }
	return newArray; }

public BitmapTransform () { 
}




}

