package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlPenManager {

public void destruct() {


}


public static FlPenManager Get () {

	 FrameworkGlobals frameworkGlobals = FrameworkGlobals.GetInstance();
	if(frameworkGlobals.mFlPenManager == null)
	{
		frameworkGlobals.mFlPenManager = new FlPenManager();
	}
	return  frameworkGlobals.mFlPenManager;

}


public byte RequestPenIndex () {








return  0;

}


public void FreePenIndex (byte index) {





}


public void Reset () {
	
	Deactivate();
	Activate();

}


public void Deactivate () {
	
	mActived = false;
	 Vector2_short invalidPt = new Vector2_short((short)-1, (short)-1);


	for(int i = 0;i < 1;i ++)
	{
		if(mLastTouchedComponent[i] != null)
		{
			mLastTouchedComponent[i].SendMsg(null, Component.penMgrDeactivatedMsg, EncodeParam(invalidPt, (byte)i));
		}

		mLastTouchedComponent[i] = null;



}

}


public void Activate () {

	mActived = true;

}


public void OnPenDown ( Vector2_short ptIn, byte penIndex) {









if(IsActive(ptIn))
	{
		 Vector2_short translatedPt = TranslatePoint(ptIn);



mLastTouchedPosition[penIndex].Assign(translatedPt);
		mLastTouchedComponent[penIndex] = Application.GetInstance().GetHitTestComponent(translatedPt.GetX(), translatedPt.GetY());







if(null != mLastTouchedComponent[penIndex])
		{
			mLastTouchedComponent[penIndex].SendMsg(null, Component.penDownMsg, EncodeParam(translatedPt, penIndex));
		}
	}
	

	Application.GetInstance().ResetLastUserInputTime();

}


public void OnPenUp ( Vector2_short ptIn, byte penIndex) {






if(IsActive(ptIn))
	{
		 Vector2_short translatedPt = TranslatePoint(ptIn);



 Component lastTouchedComponent = mLastTouchedComponent[penIndex];

		if(null != lastTouchedComponent)
		{
			lastTouchedComponent.SendMsg(null, Component.penUpMsg, EncodeParam(translatedPt, penIndex));
			mLastTouchedComponent[penIndex] = null;
		}
	}


	Application.GetInstance().ResetLastUserInputTime();

}


public void OnPenDrag ( Vector2_short ptIn, byte penIndex) {







if(IsActive(ptIn))
	{
		 Vector2_short translatedPt = TranslatePoint(ptIn);

		if(!mLastTouchedPosition[penIndex].Equals(translatedPt))
		{
			 Component touchedComponent = Application.GetInstance().GetHitTestComponent(translatedPt.GetX(), translatedPt.GetY());






mLastTouchedPosition[penIndex].Assign(translatedPt);
			 Component lastTouchedComponent = mLastTouchedComponent[penIndex];

			 int intParam = EncodeParam(translatedPt, penIndex);

			if(touchedComponent != lastTouchedComponent)
			{
				if(null != lastTouchedComponent)
				{
					lastTouchedComponent.SendMsg(null, Component.penDragOutMsg, intParam);
				}

				mLastTouchedComponent[penIndex] = touchedComponent;
			}
				
			if(null != touchedComponent)
			{
				touchedComponent.SendMsg(null, Component.penDragMsg, intParam);
			}
		}
	}


	Application.GetInstance().ResetLastUserInputTime();

}


public static int EncodeParam ( Vector2_short ptIn, byte penIndex) {

	 int encodedPositionX = ptIn.GetX() << ((((((0) + 4- 1) + 1) + 14- 1) + 1));

	 int encodedPositionY = ptIn.GetY() << ((((0) + 4- 1) + 1));

	 int encodedPenIndex = penIndex << ((0));

	return  (encodedPositionX | encodedPositionY | encodedPenIndex);

}


public static Vector2_short GetPenPosition (int param) {
	
	 short x = (short)((param >> (((((0) + 4- 1) + 1) + 14- 1) + 1) & (((2<< (14- 1- 0)) - 1) << 0)));

	 short y = (short)((param >> (((0) + 4- 1) + 1) & (((2<< (14- 1- 0)) - 1) << 0)));
	

	return  new Vector2_short(x, y);

}


public static byte GetPenIndex (int param) {
	
	return  (byte)((param >> (0) & (((2<< (4- 1- 0)) - 1) << 0)));

}


public int GetPenDownCount () {














	return  0;

}


public boolean IsActive () {

	return  IsActive(new Vector2_short((short)0, (short)0));

}


public  FlPenManager () {

	 



	for(int i = 0;i < 1;i ++)
	{
		mLastTouchedComponent[i] = null;



}

}


public byte GetFreePenIndex () {










return  0;

}


public Vector2_short TranslatePoint ( Vector2_short ptIn) {
	































return  ptIn;

}


public boolean IsActive ( Vector2_short ptIn) {








return  mActived;

}


public Component[] mLastTouchedComponent = new Component[1];

public Vector2_short[] mLastTouchedPosition = Vector2_short.InstArrayVector2_short(1);

public boolean mActived;
public void OnPenDown(Vector2_short ptIn)
{
	OnPenDown(ptIn, (byte)0);
}
public void OnPenUp(Vector2_short ptIn)
{
	OnPenUp(ptIn, (byte)0);
}
public void OnPenDrag(Vector2_short ptIn)
{
	OnPenDrag(ptIn, (byte)0);
}

/* One dimension array */
public static FlPenManager[] InstArrayFlPenManager(int size) {
	FlPenManager[] newArray = new FlPenManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlPenManager();
	return newArray; }

/* Two dimension array */
public static FlPenManager[][] InstArrayFlPenManager(int size1, int size2) {
	FlPenManager[][] newArray = new FlPenManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlPenManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlPenManager(); }
	return newArray; }

/* Three dimension array */
public static FlPenManager[][][] InstArrayFlPenManager(int size1, int size2, int size3) {
	FlPenManager[][][] newArray = new FlPenManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlPenManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlPenManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlPenManager(); } }
	return newArray; }



}

