package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class KeyFrameController extends Controller {

public static KeyFrameController Cast(Object o, KeyFrameController _) {
 return  (KeyFrameController)o; 
}


 final public static byte typeNumber = TypeIDOfType_KeyFrameController.v;
 final public static byte typeID = TypeIDOfType_KeyFrameController.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  KeyFrameController () {
super();



}


public  KeyFrameController (KeyFrameSequence seq) {
super();
mKeySequence = seq;



}


public void destruct() {

	mKeySequence = null; 

}


public void OnTime ( int totalTime, int deltaTime) {







	if(mControllee == null)
	{

		return ;
	}
	mKeySequence.GetObjectValue(totalTime, mValueBuffer);

	DefaultOnTime(totalTime, deltaTime);
  





}


public KeyFrameSequence GetKeySequence() {
 return  mKeySequence; 
}


public void SetKeySequence(KeyFrameSequence val) {
 mKeySequence = val; 
}


public void OnSerialize (Package p) {

	super.OnSerialize(p);








(mKeySequence)= mKeySequence.Cast((p).SerializePointer((mKeySequence).typeNumber, (mKeySequence).supportsDynamicSerialization, false), null);




}


public KeyFrameSequence mKeySequence;

/* One dimension array */
public static KeyFrameController[] InstArrayKeyFrameController(int size) {
	KeyFrameController[] newArray = new KeyFrameController[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new KeyFrameController();
	return newArray; }

/* Two dimension array */
public static KeyFrameController[][] InstArrayKeyFrameController(int size1, int size2) {
	KeyFrameController[][] newArray = new KeyFrameController[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeyFrameController[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new KeyFrameController(); }
	return newArray; }

/* Three dimension array */
public static KeyFrameController[][][] InstArrayKeyFrameController(int size1, int size2, int size3) {
	KeyFrameController[][][] newArray = new KeyFrameController[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeyFrameController[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new KeyFrameController[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new KeyFrameController(); } }
	return newArray; }



}

