package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class KeysBuffer {

public  KeysBuffer () {
mKeysDown = new Array_boolean();


	mKeysDown.SetSize(Key.COUNT);
	for(int i = (int)Key.UNDEFINED;i < (int)Key.COUNT;i ++)
	{
		mKeysDown.SetAt(false, i);
	}


}


public void destruct() {
mKeysDown = new Array_boolean();
  
}


public boolean IsRegistered () {

	return  mIsRegistered;

}


public boolean KeyIsDown (int key) {

	return  mKeysDown.GetAt((int)key);

}


public boolean KeyDownInRange (int keyLower, int keyUpper) {



	for(int i = (int)keyLower;i <= (int)keyUpper;++i)
	{
		if(mKeysDown.GetAt(i))
			return  true;
	}
	return  false;

}


public void OnKey (int key, boolean up) {

	mKeysDown.SetAt(!up, (int)key);

}


public boolean mIsRegistered;
public Array_boolean mKeysDown;

/* One dimension array */
public static KeysBuffer[] InstArrayKeysBuffer(int size) {
	KeysBuffer[] newArray = new KeysBuffer[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new KeysBuffer();
	return newArray; }

/* Two dimension array */
public static KeysBuffer[][] InstArrayKeysBuffer(int size1, int size2) {
	KeysBuffer[][] newArray = new KeysBuffer[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeysBuffer[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new KeysBuffer(); }
	return newArray; }

/* Three dimension array */
public static KeysBuffer[][][] InstArrayKeysBuffer(int size1, int size2, int size3) {
	KeysBuffer[][][] newArray = new KeysBuffer[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeysBuffer[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new KeysBuffer[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new KeysBuffer(); } }
	return newArray; }



}

