package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SoundFormat {

public final static short Wave = 0;
public final static short Midi = 1;
public final static short Spf = 2;
public final static short Qcp = 3;
public final static short Aac = 4;
public final static short Tone = 5;
public final static short Mmf = 6;
public final static short Imy = 7;
public final static short Mp3 = 8;
public final static short Pmd = 9;
public final static short Amr = 10;
public final static short M4a = 11;
public final static short Ogg = 12;
public final static short Unknown = 13;


/* One dimension array */
public static SoundFormat[] InstArraySoundFormat(int size) {
	SoundFormat[] newArray = new SoundFormat[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new SoundFormat();
	return newArray; }

/* Two dimension array */
public static SoundFormat[][] InstArraySoundFormat(int size1, int size2) {
	SoundFormat[][] newArray = new SoundFormat[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SoundFormat[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new SoundFormat(); }
	return newArray; }

/* Three dimension array */
public static SoundFormat[][][] InstArraySoundFormat(int size1, int size2, int size3) {
	SoundFormat[][][] newArray = new SoundFormat[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SoundFormat[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new SoundFormat[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new SoundFormat(); } }
	return newArray; }

public SoundFormat () { 
}




}

