package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Tokenizer {

public  Tokenizer ( String str) {
mStr = new String(str);
mDelim = new String();


	mDelim.InsertCharAt(0, (byte)' ');

}


public  Tokenizer ( String str, String delim) {
mStr = new String(str);
mDelim = new String(delim);



}


public void destruct() {


}


public String NextToken () {

	String token = new String();

	 byte letter = 0;


	 int len = mStr.GetLength();


	while(mCurrentLetter < len)
	{
		letter = mStr.GetCharAt(mCurrentLetter ++);

		if(IsDelim(letter)) 
		{
			if(token.GetLength() > 0)
				return  token;
		}
		else
		{
			token.AddAssign(String.FromChar(letter));
		}
	}

	return  token;

}


public String NextToken (String delim) {

	mDelim.Assign(delim);

	return  NextToken();

}


public boolean HasMoreToken () {

	if(mStr.GetCharAt(mCurrentLetter) == 0)
		return  false;
	
	 int index = mCurrentLetter;


	while(mStr.GetCharAt(index) != 0)
	{
		if(!IsDelim(mStr.GetCharAt(index)))
			return  true;
		index++;
	}

	
	return  false;

}


public int CountTokens () {

	 int tokenCount = 0;


	for(int i = 1;i < mStr.GetLength() + 1;i ++)
	{
		if((IsDelim(mStr.GetCharAt(mCurrentLetter + i)) || mStr.GetCharAt(mCurrentLetter + i) == 0) && !IsDelim(mStr.GetCharAt(mCurrentLetter + i - 1)))
		{
			tokenCount++;
		}
	}

	return  tokenCount;

}


public boolean IsDelim (byte letter) {

	 int delim = 0;


	while(mDelim.GetCharAt(delim) != 0)
	{
		if(mDelim.GetCharAt(delim ++) == letter)
		{
			return  true;
		}
	}
	
	return  false;

}


public String mStr;
public String mDelim;
public int mCurrentLetter;



}

