package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 1


public class Vector2_short {

public static Vector2_short Cast(Object o, Vector2_short _) {
 return  (Vector2_short)o; 
}


 final public static byte typeNumber = TypeIDOfType_Vector2_short.v;
 final public static byte typeID = TypeIDOfType_Vector2_short.w;
 public static final boolean supportsDynamicSerialization = false; public Vector2_short () {




}


public Vector2_short (short inx, short iny) {

	mData[0] = inx;
	mData[1] = iny;

}


public Vector2_short ( Vector2_short other) {

	mData[0] = other.mData[0];
	mData[1] = other.mData[1];

}


public  Vector2_short Assign ( Vector2_short rhs) {

	mData[0] = rhs.mData[0];
	mData[1] = rhs.mData[1];

	return this;

}


public  Vector2_short MulAssign (short rhs) {

	mData[0] *= rhs;
	mData[1] *= rhs;

	return this;

}


public  Vector2_short AddAssign ( Vector2_short rhs) {

	mData[0] = (short)(mData[0] + rhs.mData[0]);
	mData[1] = (short)(mData[1] + rhs.mData[1]);

	return this;

}


public  Vector2_short SubAssign ( Vector2_short rhs) {
	
	mData[0] = (short)(mData[0] - rhs.mData[0]);
	mData[1] = (short)(mData[1] - rhs.mData[1]);

	return this;

}


public  Vector2_short Neg () {

	return  new Vector2_short((short)(-mData[0]), (short)(-mData[1]));

}


public short GetX() {
 return  mData[0]; 
}


public short GetY() {
 return  mData[1]; 
}


public void SetX(short inx) {
 mData[0] = inx; 
}


public void SetY(short iny) {
 mData[1] = iny; 
}


public void OffsetX(short inx) {
 mData[0] = (short)(mData[0] + inx); 
}


public void OffsetY(short iny) {
 mData[1] = (short)(mData[1] + iny); 
}


public short[] mData = new short[2];

public void OnSerialize (Package p) {

	short t;

	t = mData[0]; (t)= (p).SerializeIntrinsic(t); mData[0] = t;
	t = mData[1]; (t)= (p).SerializeIntrinsic(t); mData[1] = t;

}


public boolean Equals(Vector2_short rhs) {
 return  (mData[0] == rhs.mData[0]) && (mData[1] == rhs.mData[1]);
	
}


public Vector2_short Add(short rhs) {
 return  new Vector2_short((short)(mData[0] + rhs), (short)(mData[1] + rhs));
	
}


public Vector2_short Sub(short rhs) {
 return  new Vector2_short((short)(mData[0] - rhs), (short)(mData[1] - rhs));
	
}


public Vector2_short Add(Vector2_short rhs) {
 return  new Vector2_short((short)(mData[0] + rhs.mData[0]), (short)(mData[1] + rhs.mData[1]));
	
}


public Vector2_short Sub(Vector2_short rhs) {
 return  new Vector2_short((short)(mData[0] - rhs.mData[0]), (short)(mData[1] - rhs.mData[1]));
	
}


public Vector2_short Mul(short rhs) {
 return  new Vector2_short((short)(mData[0] * rhs), (short)(mData[1] * rhs));
	
}


public Vector2_short Div(short rhs) {
 return  new Vector2_short((short)(mData[0] / rhs), (short)(mData[1] / rhs));
	
}


public short CrossProduct(Vector2_short rhs) {
 return  (short)(mData[0] * rhs.mData[1] - mData[1] * rhs.mData[0]);
	
}


public short DotProduct(Vector2_short rhs) {
 return  (short)(mData[0] * rhs.mData[0] + mData[1] * rhs.mData[1]);
	
}



/* One dimension array */
public static Vector2_short[] InstArrayVector2_short(int size) {
	Vector2_short[] newArray = new Vector2_short[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Vector2_short();
	return newArray; }

/* Two dimension array */
public static Vector2_short[][] InstArrayVector2_short(int size1, int size2) {
	Vector2_short[][] newArray = new Vector2_short[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Vector2_short[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Vector2_short(); }
	return newArray; }

/* Three dimension array */
public static Vector2_short[][][] InstArrayVector2_short(int size1, int size2, int size3) {
	Vector2_short[][][] newArray = new Vector2_short[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Vector2_short[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Vector2_short[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Vector2_short(); } }
	return newArray; }



}

