package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class InputSingleMapping extends InputMapping {

public  InputSingleMapping (int actionsCount) {
super(actionsCount);


	mCurrentMappingData = new int[GetAllMappingElementCount()];
	Reset();

}


public void destruct() {

	mCurrentMappingData = null;

}


public void Write (FileSegmentStream stream) {

	int arraySize;

	arraySize = GetAllMappingElementCount();

	for(int i = 0;i < arraySize;i ++)
	{
		stream.WriteInt(mCurrentMappingData[i]);
	}

	super.Write(stream);

}


public void Read (FileSegmentStream stream) {

	int arraySize;

	arraySize = GetAllMappingElementCount();

	for(int i = 0;i < arraySize;i ++)
	{
		mCurrentMappingData[i] = (int)stream.ReadInt();
	}

	super.Read(stream);

}


public void Reset () {

	SetDefault();

}


public void ClearInputMapping (int layoutIndex) {

	for(int i = 0;i < GetMappingCount();i ++)
	{
		ClearMapping((int)i);
	}

}


public void SetDefault(int layoutIndex)  {

}


public int[] GetCurrentMappingData() {
 return  mCurrentMappingData; 
}


public int[] mCurrentMappingData = null;
public void ClearInputMapping()
{
	ClearInputMapping((int)0);
}
public void SetDefault()
{
	SetDefault((int)0);
}



}

