package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class OptionsScene extends BaseScene {

public  OptionsScene (byte packageID, boolean isInPauseMenu) {
super(packageID);
mIsInPauseMenu = (isInPauseMenu);



}


public void destruct() {


}


public boolean HandleCommand (int command) {

	 TetrisApp tetrisApp = GetApp();
	 boolean retval = true;



	 TetrisMediaPlayer tetrisPlayer = GetApp().GetPlayer();
switch(command)
	{






case (((int)ConstantsEnglishPortrait.toggleVibrationCommand == (int)ConstantsEnglishLandscape.toggleVibrationCommand) ? Constants.toggleVibrationCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuVibrationIndex == (int)ConstantsEnglishLandscape.optionsMenuVibrationIndex) ? Constants.optionsMenuVibrationIndex : ConstantsGetter.GetConstants().optionsMenuVibrationIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();

			 boolean enableVibration = toggleOptionIndex == on;

			tetrisApp.GetOptionSettings().SetVibrationEnabled(enableVibration);
			
			if(enableVibration)
			{
				
				
				
				tetrisPlayer.StopSound();

				tetrisPlayer.StartVibration((((int)ConstantsEnglishPortrait.vibrationNormalDurationMs == (int)ConstantsEnglishLandscape.vibrationNormalDurationMs) ? Constants.vibrationNormalDurationMs : ConstantsGetter.GetConstants().vibrationNormalDurationMsFct()));
			}
			else
			{
				tetrisPlayer.StopVibration();
			}

		}
		break;
case (((int)ConstantsEnglishPortrait.toggleLanguageCommand == (int)ConstantsEnglishLandscape.toggleLanguageCommand) ? Constants.toggleLanguageCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuLanguageIndex == (int)ConstantsEnglishLandscape.optionsMenuLanguageIndex) ? Constants.optionsMenuLanguageIndex : ConstantsGetter.GetConstants().optionsMenuLanguageIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();

			LanguageManager.Get().SetLanguageFromIndex(toggleOptionIndex);
		}
		break;
case (((int)ConstantsEnglishPortrait.toggleMusicCommand == (int)ConstantsEnglishLandscape.toggleMusicCommand) ? Constants.toggleMusicCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuMusicIndex == (int)ConstantsEnglishLandscape.optionsMenuMusicIndex) ? Constants.optionsMenuMusicIndex : ConstantsGetter.GetConstants().optionsMenuMusicIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();

			 OptionSettings optionSettings = tetrisApp.GetOptionSettings();

			optionSettings.SetMusicMode((byte)toggleOptionIndex);

			if(!optionSettings.IsMusicEnabled())
			{
				tetrisPlayer.StopInGameMusic();
			}
			else 
			{

			

tetrisPlayer.PlaySong(optionSettings.GetMusicMode() == InGameMusicMode.kInGameMusic1 ? TetrisMediaPlayer.kSndInGameMusicSample1 : TetrisMediaPlayer.kSndInGameMusicSample2, true);
			}
			OnSoundMusicOptionsToggled();
		}
		break;
case (((int)ConstantsEnglishPortrait.toggleSoundCommand == (int)ConstantsEnglishLandscape.toggleSoundCommand) ? Constants.toggleSoundCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuSoundIndex == (int)ConstantsEnglishLandscape.optionsMenuSoundIndex) ? Constants.optionsMenuSoundIndex : ConstantsGetter.GetConstants().optionsMenuSoundIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();

			
			 boolean soundEnabled = toggleOptionIndex == on;

			tetrisApp.GetOptionSettings().SetSoundEnabled(soundEnabled);

			if(soundEnabled)
			{
			

tetrisPlayer.PlaySound(TetrisMediaPlayer.kSndGameOverLoose);
			}
			else
			{
				tetrisPlayer.StopSound();
			}
			OnSoundMusicOptionsToggled();
		}
		break;
case (((int)ConstantsEnglishPortrait.toggleTutorialCommand == (int)ConstantsEnglishLandscape.toggleTutorialCommand) ? Constants.toggleTutorialCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuTutorialIndex == (int)ConstantsEnglishLandscape.optionsMenuTutorialIndex) ? Constants.optionsMenuTutorialIndex : ConstantsGetter.GetConstants().optionsMenuTutorialIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();


tetrisApp.GetTetrisState().SetTutorialShowingSetting((byte)toggleOptionIndex);
		}
		break;
case (((int)ConstantsEnglishPortrait.toggleGhostCommand == (int)ConstantsEnglishLandscape.toggleGhostCommand) ? Constants.toggleGhostCommand : -123) :
		{
			 int toggleOptionIndex = ((Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuGhostIndex == (int)ConstantsEnglishLandscape.optionsMenuGhostIndex) ? Constants.optionsMenuGhostIndex : ConstantsGetter.GetConstants().optionsMenuGhostIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())))).GetSingleSelection();

			tetrisApp.GetOptionSettings().SetGhostEnabled(toggleOptionIndex == on);
		}
		break;

		default :
		{
			retval = false;
		}
		break;
	}

	
	if(!retval)
	{
		return  super.HandleCommand(command);
	}
	else
	{
		
		SaveOnExit();
	}

	return  true;

}


public void OnNeedToReloadGame () {






}


public void SetAudioSliderValue (int value) {






}


public void Init () {

	Selector subSelector = null;


	 TetrisState tetrisState = GetTetrisState();
 int startingOption = 0;


	 OptionSettings optionSettings = GetApp().GetOptionSettings();

	startingOption = optionSettings.GetMusicMode();
	subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuMusicIndex == (int)ConstantsEnglishLandscape.optionsMenuMusicIndex) ? Constants.optionsMenuMusicIndex : ConstantsGetter.GetConstants().optionsMenuMusicIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
	subSelector.SetSingleSelection(startingOption);
UpdateLogOnSelection();


	startingOption = optionSettings.IsSoundEnabled() ? on : off;






subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuSoundIndex == (int)ConstantsEnglishLandscape.optionsMenuSoundIndex) ? Constants.optionsMenuSoundIndex : ConstantsGetter.GetConstants().optionsMenuSoundIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
    subSelector.SetSingleSelection(startingOption);










GetApp().GetPlayer().LoadGameSounds();
startingOption = optionSettings.IsVibrationEnabled() ? on : off;
	subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuVibrationIndex == (int)ConstantsEnglishLandscape.optionsMenuVibrationIndex) ? Constants.optionsMenuVibrationIndex : ConstantsGetter.GetConstants().optionsMenuVibrationIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
	subSelector.SetSingleSelection(startingOption);
startingOption = tetrisState.GetTutorialShowingSetting();
	subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuTutorialIndex == (int)ConstantsEnglishLandscape.optionsMenuTutorialIndex) ? Constants.optionsMenuTutorialIndex : ConstantsGetter.GetConstants().optionsMenuTutorialIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
	subSelector.SetSingleSelection(startingOption);
startingOption = optionSettings.IsGhostEnabled() ? on : off;
	subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuGhostIndex == (int)ConstantsEnglishLandscape.optionsMenuGhostIndex) ? Constants.optionsMenuGhostIndex : ConstantsGetter.GetConstants().optionsMenuGhostIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
	subSelector.SetSingleSelection(startingOption);


	startingOption = LanguageManager.Get().GetLanguageAsIndex();
	subSelector = (Selector)(((Selector)mpComponentWithFocus).GetSelectionAt((((int)ConstantsEnglishPortrait.optionsMenuLanguageIndex == (int)ConstantsEnglishLandscape.optionsMenuLanguageIndex) ? Constants.optionsMenuLanguageIndex : ConstantsGetter.GetConstants().optionsMenuLanguageIndexFct())).GetChild((((int)ConstantsEnglishPortrait.optionsSubSelectorChildIndex == (int)ConstantsEnglishLandscape.optionsSubSelectorChildIndex) ? Constants.optionsSubSelectorChildIndex : ConstantsGetter.GetConstants().optionsSubSelectorChildIndexFct())));
	subSelector.SetSingleSelection(startingOption);
{
		 ScreenManager sm = ScreenManager.Get();
		startingOption = ScreenManager.OrientationToIndex(sm.GetOrientationSetting());
		 Selector allOptionsSelector = (Selector )mpComponentWithFocus;
		 int optionIndex = (((int)ConstantsEnglishPortrait.optionsMenuScreenRotationIndex == (int)ConstantsEnglishLandscape.optionsMenuScreenRotationIndex) ? Constants.optionsMenuScreenRotationIndex : ConstantsGetter.GetConstants().optionsMenuScreenRotationIndexFct());


		if(!sm.IsOrientationSettingNeeded())
		{
			MenuToolbox.RemoveSelectionInVerticalSelector(allOptionsSelector, optionIndex);
		}














}

 int firstItemIndex = 0;

	if(mIsInPauseMenu)
	{
		
		 Selection gameSettingsSelection = null;

		(gameSettingsSelection)= (gameSettingsSelection).Cast((mpPackage).GetEntryPoint(RSRC_optionsMenuScenePackage.singleGameSettingsSelection_ID), null);
		gameSettingsSelection.SetEnabledState(false);
		firstItemIndex++;





(gameSettingsSelection)= (gameSettingsSelection).Cast((mpPackage).GetEntryPoint(RSRC_optionsMenuScenePackage.resetStatsOptionSelection_ID), null);
		gameSettingsSelection.SetEnabledState(false);
}




























OnSoundMusicOptionsToggled();
	((Selector)mpComponentWithFocus).SetSingleSelection(firstItemIndex);

	 Scroller scroller = (Scroller)mpComponentWithFocus;
	scroller.ResetScroller();

	super.Init();

}


public void PrepareExitScene (int command) {









super.PrepareExitScene(command);

}


public boolean HandleSelectedMsg (Component source, int intParam) {






















return  super.HandleSelectedMsg(source, intParam);

}


public boolean OnKey (int key, boolean up) {










return  super.OnKey(key, up);

}


public boolean HandleSliderMsg (Component source, int intParam) {
	






























return  super.HandleSliderMsg(source, intParam);

}


public void OnMenuItemSelectionWithSliderSubtypeUIEvent (Selection selection, boolean isEnabled, boolean isSelected) {








super.OnMenuItemSelectionWithSliderSubtypeUIEvent(selection, isEnabled, isSelected);

}


public void UpdateSlider (Slider slider) {














super.UpdateSlider(slider);

}


public void HandleLogOptionToggled () {















}


public void UpdateLogOnSelection () {















}


public void OnSoundMusicOptionsToggled () {












}


public void UpdateVolumeSliderHUD (boolean isEnabled, boolean isSelected) {
























}


public boolean mIsInPauseMenu;



}

