package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class PackageID {

public final static byte invalid = -1;
public final static byte font = 0;
public final static byte commonStrings = 1;
public final static byte common = 2;
public final static byte introSound = 3;
public final static byte splashMenuScene = 4;
public final static byte menuStrings = 5;
public final static byte commonMenu = 6;
public final static byte inGameMusic1 = 7;
public final static byte inGameMusic2 = 8;
public final static byte gameSound = 9;
public final static byte emptyScene = 10;
public final static byte aboutMenuScene = 11;
public final static byte helpMenuScene = 12;
public final static byte marathonScoreMenuScene = 13;
public final static byte ultraScoreMenuScene = 14;
public final static byte fortyLinesScoreMenuScene = 15;
public final static byte moreGamesMenuScene = 16;
public final static byte delayLoadingMenuScene = 17;
public final static byte gameStrings = 18;
public final static byte gameScene = 19;
public final static byte gameSetupMenuScene = 20;
public final static byte singlePlayerModesMenuScene = 21;
public final static byte displayOrientationMenuScene = 22;
public final static byte mainMenuScene = 23;
public final static byte statisticsMenuScene = 24;
public final static byte tutorialMenuScene = 25;
public final static byte optionsMenuScene = 26;
public final static byte pauseMenuScene = 27;
public final static byte promptMenuScene = 28;
public final static byte tetriminoMarks = 29;
public final static byte minoParts = 30;
public final static byte playerMino = 31;
public final static byte highlightMino = 32;
public final static byte darkMino = 33;
public final static byte loadingHourGlass = 34;
public final static byte baseLibraryStartID = loadingHourGlass;
public final static byte blueBackground = loadingHourGlass+1;
public final static byte globalBackground = loadingHourGlass+2;
public final static byte count = loadingHourGlass+3;
public final static byte fakeMainMenuScene = -mainMenuScene	;


/* One dimension array */
public static PackageID[] InstArrayPackageID(int size) {
	PackageID[] newArray = new PackageID[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new PackageID();
	return newArray; }

/* Two dimension array */
public static PackageID[][] InstArrayPackageID(int size1, int size2) {
	PackageID[][] newArray = new PackageID[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PackageID[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new PackageID(); }
	return newArray; }

/* Three dimension array */
public static PackageID[][][] InstArrayPackageID(int size1, int size2, int size3) {
	PackageID[][][] newArray = new PackageID[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PackageID[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new PackageID[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new PackageID(); } }
	return newArray; }

public PackageID () { 
}




}

