package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SplashScene extends BaseScene {

public  SplashScene (byte packageID) {
super(packageID);



}


public void destruct() {


}


public void GetResources () {

	super.GetResources();

	
	GetApp().SetSoftKeySpriteVisible(false);

	(mpIntroTimeSystem)= (mpIntroTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_splashMenuScenePackage.splashAnimTimeSystem_ID), null);







{ 
		Component legalText = null;

		(legalText)= (legalText).Cast((mpPackage).GetEntryPoint(RSRC_splashMenuScenePackage.splashLegalText_ID), null);

		 FlRect r = new FlRect(legalText.GetRect());

		r.SetTop((short)((((int)ConstantsEnglishPortrait.screenHeight == (int)ConstantsEnglishLandscape.screenHeight) ? Constants.screenHeight : ConstantsGetter.GetConstants().screenHeightFct()) - r.GetHeight()) / 2);
		legalText.SetRect(r);	
	}

}


public void UnloadResources () {



if(mpIntroTimeSystem != null)
	{
		mpIntroTimeSystem.UnRegisterInGlobalTime();
	}

	super.UnloadResources();

}


public void OnTime (int totalTimeMs, int deltaTimeMs) {

	if(IsReadyToStartEntranceAnim())
	{



mpIntroTimeSystem.RegisterInGlobalTime();

	}

	if(mState == kDisplaying && mpIntroTimeSystem != null)
	{

		if (mpIntroTimeSystem.GetTotalTime() <= (((int)ConstantsEnglishPortrait.splashEALoadingStartMs == (int)ConstantsEnglishLandscape.splashEALoadingStartMs) ? Constants.splashEALoadingStartMs : ConstantsGetter.GetConstants().splashEALoadingStartMsFct()) &&
			mpIntroTimeSystem.GetTotalTime() + deltaTimeMs > (((int)ConstantsEnglishPortrait.splashEALoadingStartMs == (int)ConstantsEnglishLandscape.splashEALoadingStartMs) ? Constants.splashEALoadingStartMs : ConstantsGetter.GetConstants().splashEALoadingStartMsFct()))
		{
			GetApp().GetPlayer().PlaySound(TetrisMediaPlayer.kSndIntro);
		}
if(!mpIntroTimeSystem.IsPaused() && mpIntroTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.splashDuration == (int)ConstantsEnglishLandscape.splashDuration) ? Constants.splashDuration : ConstantsGetter.GetConstants().splashDurationFct()))
		{
			mpIntroTimeSystem.Pause();
			OnSplashSceneOver();
			return ;
		}
	}

	super.OnTime(totalTimeMs, deltaTimeMs);

}


public boolean OnKey (int key, boolean up) {





if(up)
	{






if(IsInTetrisLogoIntroPhase())
		{
			OnSplashSceneOver();
			return  true;
		}
}
	
	return  super.OnKey(key, up);

}


public boolean IsMenuScene() {
 return  false; 
}


public int GetReloadSceneCommand () {

	 int totalTime = 0;


	if(mpIntroTimeSystem != null)
	{
		totalTime = mpIntroTimeSystem.GetTotalTime();
	}
	
	
	if(totalTime > (((int)ConstantsEnglishPortrait.splashLegalTextEndMs == (int)ConstantsEnglishLandscape.splashLegalTextEndMs) ? Constants.splashLegalTextEndMs : ConstantsGetter.GetConstants().splashLegalTextEndMsFct())) {
		return  (((int)ConstantsEnglishPortrait.goToMainMenuCommand == (int)ConstantsEnglishLandscape.goToMainMenuCommand) ? Constants.goToMainMenuCommand : ConstantsGetter.GetConstants().goToMainMenuCommandFct());
	}

	return  super.GetReloadSceneCommand();

}


public void StartUpLicenseCheckCompleted () {





}


public boolean IsInTetrisLogoIntroPhase () {
	
	return  mpIntroTimeSystem != null && mpIntroTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.splashIntroStartTimeMs == (int)ConstantsEnglishLandscape.splashIntroStartTimeMs) ? Constants.splashIntroStartTimeMs : ConstantsGetter.GetConstants().splashIntroStartTimeMsFct());

}


public void GoToNextScene () {
	
	


 int commandAfterSplash = (((int)ConstantsEnglishPortrait.goToMainMenuCommand == (int)ConstantsEnglishLandscape.goToMainMenuCommand) ? Constants.goToMainMenuCommand : ConstantsGetter.GetConstants().goToMainMenuCommandFct());

HandleCommand(commandAfterSplash);

}


public void OnSplashSceneOver () {









GoToNextScene();

}


public TimeSystem mpIntroTimeSystem;



}

