package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import android.media.MediaPlayer;
	
public class AndroidSoundPlayerImp {

public final static short StateReset = 0;
public final static short StateStopped = 1;
public final static short StatePlayingOrPlayed = 2;
public final static short StatePaused = 3;

public  AndroidSoundPlayerImp () {
mState = (AndroidSoundPlayerImp.StateReset);
mVolume255 = (255);
mMediaPlayer = new MediaPlayer();


	mMediaPlayer = new MediaPlayer();

}


public void destruct() {

	Stop();
	mMediaPlayer.release();
	mSound = null;
	mState = AndroidSoundPlayerImp.StateStopped;

}


public void SetSound ( Sound sound) {

	if(sound == null) return ;

	mSound = sound;
	 int soundResIdx = FlAndroidApp.instance.GetResId("raw", StringUtils.CreateJavaString(sound.mImplementor.GetFileName()));

	mMediaPlayer.reset();
	mMediaPlayer = MediaPlayer.create(FlAndroidApp.instance, soundResIdx);
	mState = AndroidSoundPlayerImp.StateStopped;

}


public Sound GetSound() {
 return  mSound; 
}


public void Play () {


	
	if(mState == AndroidSoundPlayerImp.StateReset)
	{
		return ;
	}

	mMediaPlayer.setLooping(mIsLooping);
	mMediaPlayer.start();
	mState = AndroidSoundPlayerImp.StatePlayingOrPlayed;

}


public void Pause () {



	if(mState == AndroidSoundPlayerImp.StateReset)
	{
		return ;
	}

	mMediaPlayer.pause();
	mState = AndroidSoundPlayerImp.StatePaused;

}


public void Stop () {



	if(mState == AndroidSoundPlayerImp.StateReset)
	{
		return ;
	}

	mMediaPlayer.pause();
	mMediaPlayer.seekTo(0);
	mState = AndroidSoundPlayerImp.StateStopped;

}


public boolean IsPaused() {
 return  mState == StatePaused; 
}


public boolean IsPlaying() {
 return  mMediaPlayer.isPlaying(); 
}


public void SetNativeVolume() {
 
}


public void SetVolume (short volume255) {


	mVolume255 = volume255;
	
	

}


public short GetVolume() {
 return  mVolume255; 
}


public void SetLooping (boolean isLooping) {

	mIsLooping = isLooping;

}


public boolean IsLooping() {
 return  mIsLooping; 
}


public void SetMuted (boolean isMuted) {

	
	
	
	
	
	
	
	
	

	mIsMuted = isMuted;

}


public boolean IsMuted() {
 return  mIsMuted; 
}


public MediaPlayer mMediaPlayer;
public Sound mSound;
public short mState;
public short mVolume255;
public boolean mIsMuted;
public boolean mIsLooping;

/* One dimension array */
public static AndroidSoundPlayerImp[] InstArrayAndroidSoundPlayerImp(int size) {
	AndroidSoundPlayerImp[] newArray = new AndroidSoundPlayerImp[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new AndroidSoundPlayerImp();
	return newArray; }

/* Two dimension array */
public static AndroidSoundPlayerImp[][] InstArrayAndroidSoundPlayerImp(int size1, int size2) {
	AndroidSoundPlayerImp[][] newArray = new AndroidSoundPlayerImp[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new AndroidSoundPlayerImp[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new AndroidSoundPlayerImp(); }
	return newArray; }

/* Three dimension array */
public static AndroidSoundPlayerImp[][][] InstArrayAndroidSoundPlayerImp(int size1, int size2, int size3) {
	AndroidSoundPlayerImp[][][] newArray = new AndroidSoundPlayerImp[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new AndroidSoundPlayerImp[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new AndroidSoundPlayerImp[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new AndroidSoundPlayerImp(); } }
	return newArray; }



}

