package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public abstract class Bitmap {

public static Bitmap Cast(Object o, Bitmap _) {
 return  (Bitmap)o; 
}


 final public static byte typeNumber = TypeIDOfType_Bitmap.v;
 final public static byte typeID = TypeIDOfType_Bitmap.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Bitmap () {
mIsDynamic = (true);
mPower2Size = new Vector2_short();
mColorKey = new Color888();
mBlendingColor = new Color888();



}


public void destruct() {


}


public short GetWidth () {



return  mDataWidth;

}


public short GetHeight () {



return  mDataHeight;

}


public short GetDataWidth () {

	return  mDataWidth;

}


public short GetDataHeight () {

	return  mDataHeight;

}


public short GetPaddedWidth () {
 

	return  	mPaddedWidth;



}


public short GetPaddedHeight () {
 

	return  mPaddedHeight;



}


public abstract void SetSize(short a14, short a13);



public abstract void Clone(Bitmap a15);



public abstract void Duplicate(Bitmap a16);



public abstract Palette GetPalette();



public abstract void SetPalette(Palette a17);



public void OnSerialize(Package _package) {

}


public int GetFlags () {

	return  mFlags;

}


public void SetFlags (int newFlags) {

	mFlags = newFlags;

}


public int GetPixelFormat () {

	return  (int)(mFlags & PIXEL_FORMAT_MASK);

}


public void SetPixelFormat (int newPixelFormat) {


	mFlags &= ~PIXEL_FORMAT_MASK;
	mFlags |= newPixelFormat;

}


public void SetIsColorKeyed (boolean isColorKeyed) {

	if(isColorKeyed) mFlags |= IS_COLOR_KEYED_MASK;
	else mFlags &= ~IS_COLOR_KEYED_MASK;

}


public boolean IsColorKeyed () {

	return  ((mFlags & IS_COLOR_KEYED_MASK) != 0);

}


public void SetIsRepalettized (boolean isRepalettized) {

	if(isRepalettized) mFlags |= IS_REPALETTIZED_MASK;
	else mFlags &= ~IS_REPALETTIZED_MASK;

}


public boolean IsRepalettized () {

	return  ((mFlags & IS_REPALETTIZED_MASK) != 0);

}


public void SetIsAdditiveTransparency (boolean newIsAdditiveTransparency) {

	if(newIsAdditiveTransparency) mFlags |= IS_ADDITIVE_MASK;
	else mFlags &= ~IS_ADDITIVE_MASK;

}


public boolean IsAdditiveTransparency () {

	return  ((mFlags & IS_ADDITIVE_MASK) != 0);

}


public boolean IsBlendingColor() {
 return  mIsBlendingColor; 
}


public Color888 GetBlendingColor() {
 return  mBlendingColor; 
}


public void SetIsBlendingColor(boolean isBlendingColor) {
 mIsBlendingColor = isBlendingColor;  
}


public void SetBlendingColor(Color888 blendingColor) {
 mBlendingColor.Assign(blendingColor); 
}


public boolean HasAlpha () {

	return  PixelFormat.HasAlpha(GetPixelFormat());

}


public Color888 GetColorKey () {

	return  mColorKey;

}


public void SetColorKey ( Color888 color) {

	mColorKey.Assign(color);

}


public boolean IsDynamic () {

	return  mIsDynamic;

}


public int GetBytesPerLine () {



	
	if (
		

mIsUseAlphaBlending ||
		false)
	

{
		return  mDataWidth * PixelFormat.GetBytesPerPixel(GetPixelFormat());
	}
	else
	{
		return  mDataWidth * 4; 
	}





}


public boolean IsUseAlphaBlending() {
 return  mIsUseAlphaBlending; 
}


public void SetIsUseAlphaBlending(boolean isUseAlphaBlending) {
 mIsUseAlphaBlending = isUseAlphaBlending; 
}







public abstract android.graphics.Bitmap getImage();


public byte[] mData = null;
public Vector2_short mPower2Size;
public short mPaddedWidth;
public short mPaddedHeight;
public int[] mInflatedData = null;
public final static int IS_REPAL_FLIPPED_MASK = 0x00800000;
public final static int IS_FLIPPED_XY_MASK = 0x00400000;
public final static int IS_FLIPPED_Y_MASK = 0x00200000;
public final static int IS_FLIPPED_X_MASK = 0x00100000;
public final static int IS_ADDITIVE_MASK = 0x00080000;
public final static int IS_REPALETTIZED_MASK = 0x00040000;
public final static int IS_COLOR_KEYED_MASK = 0x00020000;
public final static int PIXEL_FORMAT_MASK = 0x0000FFFF;

public short mDataWidth;
public short mDataHeight;
public Color888 mColorKey;
public int mFlags;
public boolean mIsDynamic;
public boolean mIsUseAlphaBlending;
public boolean mIsBlendingColor;
public Color888 mBlendingColor;



}

