package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BitmapImplementor extends Bitmap {

public static BitmapImplementor Cast(Object o, BitmapImplementor _) {
 return  (BitmapImplementor)o; 
}


 final public static byte typeNumber = TypeIDOfType_BitmapImplementor.v;
 final public static byte typeID = TypeIDOfType_BitmapImplementor.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public BitmapImplementor () {


	SetPixelFormat(PixelFormat.RGBA8888);

}


public BitmapImplementor ( String filePath) {

	 java.lang.String strFileName = new java.lang.String(StringUtils.CreateJavaString(String.FromChar((byte)'/').Add(filePath)));



mImage = android.graphics.BitmapFactory.decodeStream(getClass().getResourceAsStream(strFileName));




























if(mImage != null)
	{
		mDataWidth = (short)mImage.getWidth();
		mDataHeight = (short)mImage.getHeight();
	}


}


public void destruct() {


}


public void SetSize (short width, short height) {


	ReallocateData(width, height);

	


}


public void Clone ( Bitmap inBitmap) {



}


public void Duplicate ( Bitmap inBitmap) {



}


public void OnSerialize (Package p) {

	
	



(mIsUseAlphaBlending)= (p).SerializeIntrinsic(mIsUseAlphaBlending);
	(mIsBlendingColor)= (p).SerializeIntrinsic(mIsBlendingColor);			
	if(IsBlendingColor())
	{
		(mBlendingColor).OnSerialize(p);
	}
if (
		

mIsUseAlphaBlending ||
		false)
	{
		

		(mDataWidth)= (p).SerializeIntrinsic(mDataWidth);
		(mDataHeight)= (p).SerializeIntrinsic(mDataHeight);
		(mFlags)= (p).SerializeIntrinsic(mFlags);

		
		if(IsColorKeyed())
		{
			(mColorKey).OnSerialize(p);

			



}

		
		if(GetPixelFormat() == PixelFormat.ARGB8888)
		{
			(mInflatedData)= (p).SerializeIntrinsics(mInflatedData, mDataHeight * GetBytesPerLine() / 4);
		}
		else
		{
			(mData)= (p).SerializeIntrinsics(mData, mDataHeight * GetBytesPerLine());
		}

		 Palette pPalette = null;
		(pPalette)= pPalette.Cast((p).SerializePointer((pPalette).typeNumber, (pPalette).supportsDynamicSerialization, false), null);
		

		




if(pPalette != null)
			{
				
				if(mIsUseAlphaBlending)
				{
					CreateImageForBlending(mDataWidth, mDataHeight, mData, pPalette.GetData());
				}
				else
				{
					

}
			}
			else
			{
				
				if(mIsUseAlphaBlending)
				{
					CreateImageForBlending(mDataWidth, mDataHeight, mData);
				}
				else
				{
					

}
			}
		if(!IsRepalettized())
			{
				mData = null;
			}
		}
if (
		

!mIsUseAlphaBlending &&
		true)
	{
		 byte[] bData = null;
		 short paletteNumColors = 0;


		
		 int dataLength = 0;

		(dataLength)= (p).SerializeIntrinsic(dataLength);

		
		
		(paletteNumColors)= (p).SerializeIntrinsic(paletteNumColors);

		
		
		 short transNumElements = 0;

		(transNumElements)= (p).SerializeIntrinsic(transNumElements);

		
		 boolean isRepalettized = false;

		(isRepalettized)= (p).SerializeIntrinsic(isRepalettized);

		
		 int sizeToCreate = PNG_HEADER_SIZE + PNG_HEADER_DATA;


		
		 int sizeOfPaletteResource = paletteNumColors * PNG_PALETTE_SIZE_PER_COLOR;

		if(paletteNumColors > 0)
		{
			sizeOfPaletteResource += PNG_CHUNK_OVERHEAD;
			sizeToCreate += sizeOfPaletteResource;
		}

		 int sizeOfTransResource = transNumElements;

		if(transNumElements > 0)
		{
			sizeOfTransResource += PNG_CHUNK_OVERHEAD;
			sizeToCreate += sizeOfTransResource;
			dataLength -= transNumElements + PNG_CRC_OVERHEAD;
		}

		sizeToCreate += PNG_IDATSIZE_SIZE + dataLength - PNG_HEADER_SIZE_IN_PACKAGE + PNG_IEND_SIZE + PNG_CRC_OVERHEAD;

		


		bData = new byte[sizeToCreate];

		


		 int pos = 0;


		
		pos = StringUtils.StringToBytes(PNG_HEADER, bData, pos);

		
		pos = Library_loadBytes(p, PNG_HEADER_DATA, bData, pos);

		


		
		pos += sizeOfPaletteResource;

		
		if(transNumElements > 0)
		{
			
			bData[pos++] = 0;         
			bData[pos++] = 0;         
			bData[pos++] = (byte)(transNumElements >>> 8);
			bData[pos++] = (byte)(transNumElements & 0x00ff);

			
			pos = StringUtils.StringToBytes(PNG_TRNS, bData, pos);

			
			pos = Library_loadBytes(p, transNumElements + PNG_CRC_OVERHEAD, bData, pos);
		}

		
		pos = Library_loadBytes(p, PNG_IDATSIZE_SIZE, bData, pos);

		
		pos = StringUtils.StringToBytes(PNG_IDAT, bData, pos);

		
		pos = Library_loadBytes(p, dataLength - PNG_HEADER_SIZE_IN_PACKAGE, bData, pos);

		
		pos = StringUtils.StringToBytes(PNG_IEND, bData, pos);
		

		

		 Palette palette = null;
		(palette)= palette.Cast((p).SerializePointer((palette).typeNumber, (palette).supportsDynamicSerialization, false), null);

		












CreateImage(bData, palette.GetData());

		if(!isRepalettized)
		{
			bData = null;
		}

		mData = bData;
	}

}


public Palette GetPalette () {


		return  null;
	
}


public void SetPalette ( Palette newPalette) {


	
}


public void CreateImageFromRawData (byte[] rawData, byte[] palData, short width, short height) {

		CreateImageFromRawData(rawData, palData, width, height, -1);
	
}


public void CreateImageFromRawData (byte[] rawData, byte[] palData, short width, short height, int colorKeyIndex) {

		












































 byte[] pngBuffer = CreatePNGBuffer(rawData, palData, width, height, colorKeyIndex);
			





















mImage = new android.graphics.drawable.BitmapDrawable(new java.io.ByteArrayInputStream(pngBuffer, 0, pngBuffer.length)).getBitmap();
				
			





mDataWidth = width;
		mDataHeight = height;
	
}


public void CreateImageFromRawData (byte[] rawData, byte[] palData, short width, short height, Color888 colorKey) {

		 int colorKeyIndex = -1;

		 int numColor = palData.length / 3;


		for(int i = 0;i < numColor;i ++)
		{
			if ((((int)palData[i * 3]) & 0xff) == colorKey.GetRed() &&
				(((int)palData[i * 3 + 1]) & 0xff) == colorKey.GetGreen() &&
				(((int)palData[i * 3 + 2]) & 0xff) == colorKey.GetBlue())
			{
				colorKeyIndex = i;
				break;
			}
		}

		CreateImageFromRawData(rawData, palData, width, height, colorKeyIndex);
	
}


public byte[] CreatePNGBuffer (byte[] rawData, byte[] plteData, short width, short height, int colorKeyIndex) {

		byte[] pngBuffer = null;

		

		

{
			
			
			int nbZlibBlocks = (0xfb + (width * height + height)) / 0xfc;

			










			int pngSize = 75 + plteData.length + width * height + height + 5 * nbZlibBlocks;
			int trnsSize = plteData.length / 3;

			if (colorKeyIndex != -1)
			{
				pngSize += 12 + trnsSize;
			}

			pngBuffer = new byte[pngSize];

			int pos = 0;

			

			
			pos = StringUtils.StringToBytes(PNG_HEADER, pngBuffer, 0);
			pngBuffer[11] = 13;

			int startCRC = 12;

			pos = Memory.WriteIntToByteArray(width, pngBuffer, pos);

			pos = Memory.WriteIntToByteArray(height, pngBuffer, pos);

			pngBuffer[pos++] = 8; 
			pngBuffer[pos++] = 3; 
			pos += 3; 

			
				int crc = (int)Memory.CalculateCRC(pngBuffer, startCRC, pos - startCRC);
				pos = Memory.WriteIntToByteArray(crc, pngBuffer, pos);
			

pos = Memory.WriteIntToByteArray(plteData.length, pngBuffer, pos);

			startCRC = pos;

			
			pos = StringUtils.StringToBytes(PNG_PLTE, pngBuffer, pos);

			
			System.arraycopy(plteData, 0, pngBuffer, pos, plteData.length);
			pos += plteData.length;

			
				crc = (int)Memory.CalculateCRC(pngBuffer, startCRC, pos - startCRC);
				pos = Memory.WriteIntToByteArray(crc, pngBuffer, pos);
			

if (colorKeyIndex != -1)
			{
				
				pos = Memory.WriteIntToByteArray(trnsSize, pngBuffer, pos);

				startCRC = pos;

				
				pos = StringUtils.StringToBytes(PNG_TRNS, pngBuffer, pos);

				
				for (int i = 0; i < trnsSize; i++)
				{
					pngBuffer[pos + i] = (byte)0xff;
				}

				pngBuffer[pos + colorKeyIndex] = 0;

				pos += trnsSize;

				
					crc = (int)Memory.CalculateCRC(pngBuffer, startCRC, pos - startCRC);
					pos = Memory.WriteIntToByteArray(crc, pngBuffer, pos);
				

}
			
			

			
			int dataLength = (width * height + 2 + 4 + height + 5 * nbZlibBlocks);

			
			pos = Memory.WriteIntToByteArray(dataLength, pngBuffer, pos);

			startCRC = pos;

			
			pos = StringUtils.StringToBytes(PNG_IDAT, pngBuffer, pos);

			pngBuffer[pos++] = 0x18; 
			pngBuffer[pos++] = 0x19; 

			
			
			int i;
			int rawPos = 0;
			byte[] rawBuffer = new byte[(width + 1) * height];
			
			

			for (i = 0; i < height; i++)    
			{
				
				rawBuffer[rawPos++] = 0;
				System.arraycopy(rawData, i * width, rawBuffer, rawPos, width);
				rawPos += width;
			}

			

			int rawSize = rawPos;
			int blockLen = 0xfc;
			byte isEnd = 0;
			rawPos = 0;
			while (rawSize - rawPos > 0)
			{
				if (rawSize - rawPos <= 0xfc)
				{
					isEnd = (byte)1;
					blockLen = rawSize - rawPos;
				}
				

				pngBuffer[pos++] = isEnd; 
				
				pngBuffer[pos++] = (byte)blockLen;
				pngBuffer[pos++] = 0x00;
				
				pngBuffer[pos++] = (byte)(0xff - blockLen);
				pngBuffer[pos++] = (byte)0xff;
				System.arraycopy(rawBuffer, rawPos, pngBuffer, pos, blockLen);
				pos += blockLen;
				rawPos += blockLen;
			}

			
			
			

			int sum1 = 1;
			int sum2 = 0;

			for (i = 0; i < rawBuffer.length; i++)
			{
				sum1 += ((int)rawBuffer[i] & 0xff);
				sum1 %= 65521;
				sum2 += sum1;
				sum2 %= 65521;
			}

			pngBuffer[pos++] = (byte)((sum2 & 0xff00) >> 8);
			pngBuffer[pos++] = (byte)(sum2 & 0x00ff);
			pngBuffer[pos++] = (byte)((sum1 & 0xff00) >> 8);
			pngBuffer[pos++] = (byte)(sum1 & 0x00ff);

			
				crc = (int)Memory.CalculateCRC(pngBuffer, startCRC, pos - startCRC);
				pos = Memory.WriteIntToByteArray(crc, pngBuffer, pos);
			

pos += 2; 

			

			
			pos = StringUtils.StringToBytes(PNG_IEND, pngBuffer, pos);
		}
		






		return  pngBuffer;		
	
}


public void CloneAttributes ( Bitmap inBitmap) {



mIsUseAlphaBlending = inBitmap.IsUseAlphaBlending();
mDataWidth = inBitmap.GetDataWidth();
	mDataHeight = inBitmap.GetDataHeight();

	mFlags = inBitmap.GetFlags();
	mColorKey.Assign(inBitmap.GetColorKey());

}







public android.graphics.Bitmap getImage() { return mImage; }
	public android.graphics.Bitmap mImage;
public int Library_loadBytes(Package p, int bytesToRead, byte[] buffer, int whereInBuffer) {
 p.ReadBufferAtOffset(buffer, whereInBuffer, bytesToRead);
		return  whereInBuffer + bytesToRead;
	
}



		static final java.lang.String PNG_HEADER = "\u8950\u4e47\u0d0a\u1a0a\u0000\r\u4948\u4452";
		static final int PNG_HEADER_SIZE = 16;
		static final int PNG_HEADER_DATA = 17;
		static final java.lang.String PNG_PLTE = "\u504C\u5445";
		static final int PNG_PLTE_SIZE = 4;
		static final java.lang.String PNG_TRNS = "\u7452\u4e53";
		static final int PNG_TRNS_SIZE = 4;
		static final int PNG_IDATSIZE_SIZE = 4;
		static final java.lang.String PNG_IDAT = "\u4944\u4154";
		static final int PNG_IDAT_SIZE = 4;
		static final java.lang.String PNG_IEND = "\u0000\u4945\u4E44\uAE42\u6082";
		static final int PNG_IEND_SIZE = 10;
		static final int PNG_EMBEDDED_DATA_SIZE = PNG_HEADER_SIZE + PNG_IDAT_SIZE + PNG_IEND_SIZE;
		static final int PNG_BYTECOUNT_OVERHEAD = 4;
		static final int PNG_CRC_OVERHEAD = 4;
		static final int PNG_CHUNK_OVERHEAD = PNG_BYTECOUNT_OVERHEAD + PNG_PLTE_SIZE + PNG_CRC_OVERHEAD;
		static final int PNG_HEADER_SIZE_IN_PACKAGE = PNG_HEADER_DATA + PNG_IDATSIZE_SIZE;
		static final int PNG_PALETTE_SIZE_PER_COLOR = 3;
		static final int PNG_PALETTE_FOOTER_SIZE = 4;
		static final int PNG_PALETTE_POSITION_IN_PNG = PNG_HEADER_SIZE + PNG_HEADER_DATA;
		public void CreateImageForRepalettization (Bitmap sourceBitmap, Palette palette) {










CreateImage(sourceBitmap.mData, palette.GetData());
mData = null;

}


public void ReallocateData (short width, short height) {



if(mDataWidth == width && mDataHeight == height) return ;

	mData = null;
	mDataWidth = width;
	mDataHeight = height;




mData = new byte[height * (short)GetBytesPerLine()];;

}


public void CreateImageForBlending (short width, short height, byte[] bitmap) {

		


			 int pixelFormat = GetPixelFormat();

			
			if (mInflatedData == null && mData != null && !PixelFormat.IsIndexed(pixelFormat))
			{
				mInflatedData = new int[mData.length / PixelFormat.GetBytesPerPixel(pixelFormat)];
				int newIdx = 0;

				if (pixelFormat == PixelFormat.A8)
				{
					int blendingcolor = (int) 0xFFFFFF;
					
					;
					if(IsBlendingColor())
					{
						Color888 blendColor = GetBlendingColor();
						blendingcolor = (int)((blendColor.GetRed()) << 16 | ((blendColor.GetGreen()) << 8) | (blendColor.GetBlue() ));
					}
					for (int idx = 0 ; idx < mData.length ; )
					{
						mInflatedData[newIdx++] = (int)( blendingcolor |((mData[idx++] & 0xFF) << 24));
					}
				}
				else if (pixelFormat == PixelFormat.ARGB4444)
				{
					for (int idx = 0 ; idx < mData.length ; )
					{
						short color = (short)((mData[idx++] & 0xFF) | ((mData[idx++] & 0xFF) << 8));
						mInflatedData[newIdx++] = ((color & 0xF000) << 16) + ((color & 0x0F00) << 12) +  + ((color & 0x00F0) << 8) + ((color & 0x000F) << 4);
					}
				}
			}

			if (pixelFormat == PixelFormat.ARGB4444)
			{
				mImage = android.graphics.Bitmap.createBitmap(mInflatedData, width, height, android.graphics.Bitmap.Config.ARGB_4444);
			}
			else
			{
				mImage = android.graphics.Bitmap.createBitmap(mInflatedData, width, height, android.graphics.Bitmap.Config.ARGB_8888);
			}
		
		
}


public void CreateImageForBlending (short width, short height, byte[] bitmap, byte[] palette) {

		
			if(IsColorKeyed())
			{
				CreateImageFromRawData(bitmap, palette, width, height, mColorKey);
			}
			else
			{
				CreateImageFromRawData(bitmap, palette, width, height);
			}
		
}


public void CreateImage (byte[] bitmap, byte[] palette) {




		
		 int numBytes = palette.length - PNG_CRC_OVERHEAD;


		bitmap[PNG_PALETTE_POSITION_IN_PNG + 0] = 0;         
		bitmap[PNG_PALETTE_POSITION_IN_PNG + 1] = 0;         
		bitmap[PNG_PALETTE_POSITION_IN_PNG + 2] = (byte)(numBytes >>> 8);
		bitmap[PNG_PALETTE_POSITION_IN_PNG + 3] = (byte)(numBytes & 0x00ff);

		StringUtils.StringToBytes(PNG_PLTE, bitmap, PNG_PALETTE_POSITION_IN_PNG + PNG_BYTECOUNT_OVERHEAD);

		System.arraycopy(palette, 0, bitmap, PNG_PALETTE_POSITION_IN_PNG + PNG_BYTECOUNT_OVERHEAD + PNG_PLTE_SIZE, palette.length);

		
			mImage = new android.graphics.drawable.BitmapDrawable(new java.io.ByteArrayInputStream(bitmap, 0, bitmap.length)).getBitmap();
			mDataWidth = (short)mImage.getWidth();
			mDataHeight = (short)mImage.getHeight();
			
		













}



/* One dimension array */
public static BitmapImplementor[] InstArrayBitmapImplementor(int size) {
	BitmapImplementor[] newArray = new BitmapImplementor[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BitmapImplementor();
	return newArray; }

/* Two dimension array */
public static BitmapImplementor[][] InstArrayBitmapImplementor(int size1, int size2) {
	BitmapImplementor[][] newArray = new BitmapImplementor[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapImplementor[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BitmapImplementor(); }
	return newArray; }

/* Three dimension array */
public static BitmapImplementor[][][] InstArrayBitmapImplementor(int size1, int size2, int size3) {
	BitmapImplementor[][][] newArray = new BitmapImplementor[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapImplementor[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BitmapImplementor[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BitmapImplementor(); } }
	return newArray; }



}

