package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ButtonState {

public final static int STATE_NORMAL = 0;
public final static int STATE_HOVERED = 1;
public final static int STATE_PUSHED = 2;
public final static int STATE_DISABLED = 3;
public final static int STATE_FOCUSED = 4;
public final static int STATE_TOTAL = 5;


/* One dimension array */
public static ButtonState[] InstArrayButtonState(int size) {
	ButtonState[] newArray = new ButtonState[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new ButtonState();
	return newArray; }

/* Two dimension array */
public static ButtonState[][] InstArrayButtonState(int size1, int size2) {
	ButtonState[][] newArray = new ButtonState[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ButtonState[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new ButtonState(); }
	return newArray; }

/* Three dimension array */
public static ButtonState[][][] InstArrayButtonState(int size1, int size2, int size3) {
	ButtonState[][][] newArray = new ButtonState[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ButtonState[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new ButtonState[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new ButtonState(); } }
	return newArray; }

public ButtonState () { 
}




}

