package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import android.hardware.SensorManager;
	import android.hardware.SensorListener;
	
public class FlAccelerometerImp implements SensorListener {

public FlAccelerometerImp () {

	mSensorManager = (SensorManager)FlAndroidApp.instance.getSystemService(FlAndroidApp.instance.SENSOR_SERVICE);

	for(int i =0;i <3;i ++) {
		mLastValues[i] = 0.0f;
	}

}


public void Enable () {

	mSensorManager.registerListener(this, SensorManager.SENSOR_ACCELEROMETER, SensorManager.SENSOR_DELAY_NORMAL);

}


public void Disable () {

	mSensorManager.unregisterListener(this);

}


public void SetUpdateFrequency (F32 freq) {



}


public FVec3T_F32 GetAcceleration () {

	synchronized(this) 
	{
		return  new FVec3T_F32(new F32(mLastValues[0], 16), new F32(mLastValues[1], 16), new F32(mLastValues[2], 16));
	}

}


public void onSensorChanged (int sensor, float [] values) {

	if(sensor == SensorManager.SENSOR_ACCELEROMETER)
	{
		synchronized(this) 
		{
			for(int i =0;i <3;i ++) 
			{
				mLastValues[i] = values[i];
			}
		}
	}

}


public void onAccuracyChanged(int a6, int a5) {
 
}


public SensorManager mSensorManager;

	float   mLastValues[] = new float[3];
	
/* One dimension array */
public static FlAccelerometerImp[] InstArrayFlAccelerometerImp(int size) {
	FlAccelerometerImp[] newArray = new FlAccelerometerImp[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlAccelerometerImp();
	return newArray; }

/* Two dimension array */
public static FlAccelerometerImp[][] InstArrayFlAccelerometerImp(int size1, int size2) {
	FlAccelerometerImp[][] newArray = new FlAccelerometerImp[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAccelerometerImp[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlAccelerometerImp(); }
	return newArray; }

/* Three dimension array */
public static FlAccelerometerImp[][][] InstArrayFlAccelerometerImp(int size1, int size2, int size3) {
	FlAccelerometerImp[][][] newArray = new FlAccelerometerImp[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAccelerometerImp[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlAccelerometerImp[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlAccelerometerImp(); } }
	return newArray; }



}

