package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlBitmapFontBlob extends FlFontBlob {

public static FlBitmapFontBlob Cast(Object o, FlBitmapFontBlob _) {
 return  (FlBitmapFontBlob)o; 
}


 final public static byte typeNumber = TypeIDOfType_FlBitmapFontBlob.v;
 final public static byte typeID = TypeIDOfType_FlBitmapFontBlob.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public static int kHighestFontFileVersion = 6;
public final static byte BFBElementCharCode = 1;
public final static byte BFBElementSourceLeft = 6;
public final static byte BFBElementSourceTop = 7;
public final static byte BFBElementSourceWidth = 4;
public final static byte BFBElementSourceHeight = 5;
public final static byte BFBElementAdvance = 0;
public final static byte BFBElementRecede = 2;
public final static byte BFBElementOffsetY = 3;

public final static byte BFBElement_to_BMBElementRecedeForMapBlob = BitmapMapBlob.offsetX;
public final static byte BFBElement_to_BMBElementAdvanceForMapBlob = BitmapMapBlob.publicSizeX;
public final static byte BFBElement_to_BMBElementSizeYForMapBlob = BitmapMapBlob.publicSizeY;
public final static byte BFBElement_to_BMBElementWidthForMapBlob = BitmapMapBlob.sourceWidth	;

public FlBitmapFontBlob () {


}


public void destruct() {

	mIndexFromCharCode = null;
	mFontMetrics = null;












}


public FlFontBlob OnSerialize (Package p) {

	(mBitmapMapBlob)= mBitmapMapBlob.Cast((p).SerializePointer((mBitmapMapBlob).typeNumber, (mBitmapMapBlob).supportsDynamicSerialization, false), null);













{
		 int nbValues = 0;

		(nbValues)= (p).SerializeIntrinsic(nbValues);


mIndexFromCharCode = new short[nbValues];
}

	
	 int numBytesToSerialize = metricsCount;

	




(mFontMetrics)= (p).SerializeIntrinsics(mFontMetrics, numBytesToSerialize);


























return  this;

}


public byte GetLineHeight() {
 return  mFontMetrics[metricsLineHeight];	
}


public byte GetLeading() {
 return  mFontMetrics[metricsLeading];		
}


public void SetLeading (byte newLeading) {

	 int deltaLeading = mFontMetrics[metricsLeading] - newLeading;

	mFontMetrics[metricsLineHeight] = (byte)(mFontMetrics[metricsLineHeight] - deltaLeading);






}


public void CreateCharCodeMap (short[] dataMatrix, int charCount) {



	if(mIndexFromCharCode[fieldCharCodeMapCount] == 0)
	{
		int i;

		
		

		 int lowCode = (((int)dataMatrix[BFBElement_to_BMBElementSizeYForMapBlob]) & 0xff);

		 int highCode = (((int)dataMatrix[((charCount - 1) << 3) + BFBElement_to_BMBElementSizeYForMapBlob]) & 0xff);

		 short[] newValues = mIndexFromCharCode;

		for(i = lowCode;i <= highCode;++i)
		{
			newValues[fieldCharCodeMap + i - lowCode] = ((int)-1);
		}

		for(i = 0;i < charCount;++i)
		{
			 int charCode = (((int)dataMatrix[((int)i << 3) + BFBElement_to_BMBElementSizeYForMapBlob]) & 0xff);


			newValues[fieldCharCodeMap + charCode - lowCode] = (short)i;
		}

		newValues[fieldLowestCharCode] = (short)lowCode;
		newValues[fieldCharCodeMapCount] = (short)(highCode - lowCode + 1);
	}

}


public boolean ValidateString ( String toValidate) {

	for(int i = 0;i < toValidate.GetLength();i ++)
	{
		if(GetIndexOfChar(toValidate.GetCharAt(i)) == (((int)((int)-1)) & 0xff))
		{
			return  false;
		}
	}
	return  true;

}


public void DrawString ( BitmapMap bitmapMap, DisplayContext displayContext, String string, short pointX, short pointY, int start, int length, short opacity) {

	if(length == 0)
	{
		return ;
	}

	if(length < 0)
	{
		length = string.GetLength() - start;
	}

	 int letterIndex = start;

	 boolean firstLetter = true;














































{
		do
		{
			 byte cLetter = GetIdenticalChar(string.GetCharAt(letterIndex ++), length == 1);


			if(cLetter != 0)
			{
				 int i = GetIndexOfChar(cLetter);


				if(i != (((int)((int)-1)) & 0xff))			
				{
					pointX = DrawChar(bitmapMap, displayContext, i, pointX, pointY, firstLetter, opacity);
					firstLetter = false;
				}
			}
		}
		while((--length) != 0);
	}

}


public int GetLineWidth ( BitmapMap bitmapMap, String string, int start, int length, boolean removeLastAdvance, boolean isBeginOfString) {

	 int size = 0;

	 int letterIndex = start;


	if(length < 0)
	{
		length = string.GetLength() - letterIndex;
	}
	
	if(length > 0)
	{
		 boolean first = isBeginOfString;

		 byte letter = 0;


		do
		{
			letter = string.GetCharAt(letterIndex + length - 1);
		}
		while((letter == (byte)'\u00FF' || letter == (byte)'\n' || GetIndexOfChar(letter) == (((int)((int)-1)) & 0xff)) && (--length > 0));

























while((length --) > 0)
		{		
			size += GetCharWidth(bitmapMap, string.GetCharAt(letterIndex ++), first, (length <= 0), removeLastAdvance);
			first = false;
		}
}

	return  size;

}


public int GetCharWidth ( BitmapMap bitmapMap, byte letter, boolean isFirst, boolean isLast, boolean removeLastAdvance) {

	 short[] dataMatrix = bitmapMap.mBlob.mDataMatrix;


	letter = GetIdenticalChar(letter, isLast);
	 int index = GetIndexOfChar(letter);


	int size;

	if(index == (((int)((int)-1)) & 0xff))
	{		
		size = 0;
	}
	else
	{
		 int baseIndex = (index << 3);


		if(isLast && removeLastAdvance)
		{
			
			size = dataMatrix[baseIndex + BFBElement_to_BMBElementWidthForMapBlob];
		}
		else
		{
			size = dataMatrix[baseIndex + BFBElement_to_BMBElementAdvanceForMapBlob];
		}		

		if(!isFirst)
		{
			
			size += dataMatrix[baseIndex + BFBElement_to_BMBElementRecedeForMapBlob];
		}
	}

	return  size;

}


public int GetCharRecede ( BitmapMap bitmapMap, byte letter, boolean isLast) {

	 short[] dataMatrix = bitmapMap.mBlob.mDataMatrix;


	letter = GetIdenticalChar(letter, isLast);
	 int index = GetIndexOfChar(letter);


	 int size = 0;

	if(index != (((int)((int)-1)) & 0xff))
	{
		 int baseIndex = (index << 3);

		size = dataMatrix[baseIndex + BFBElement_to_BMBElementRecedeForMapBlob];
	}

	return  size;

}


public final static byte fieldLowestCharCode = 0;
public final static byte fieldCharCodeMapCount = 1;
public final static byte fieldCharCodeMap = 2;

public final static byte metricsVersion = 0;
public final static byte metricsLineHeight = 1;
public final static byte metricsLeading = 2;
public final static byte metricsCount = 3;

public short DrawChar ( BitmapMap bitmapMap, DisplayContext displayContext, int charIndex, short pointX, short pointY, boolean isFirstLetter, short opacity) {

	 short[] dataMatrix = bitmapMap.mBlob.mDataMatrix;
	 int baseIndex = (charIndex << 3);


	 short advance = dataMatrix[baseIndex + BFBElement_to_BMBElementAdvanceForMapBlob];

	 short recede = dataMatrix[baseIndex + BFBElement_to_BMBElementRecedeForMapBlob];


	if(isFirstLetter)
	{
		pointX = (short)(pointX - recede);	
	}
	
	
	
	bitmapMap.DrawElementAt(charIndex, displayContext, pointX, pointY, advance, dataMatrix[baseIndex + BFBElement_to_BMBElementSizeYForMapBlob], opacity, false, false);

	
	pointX = (short)(pointX + advance + recede);

	return  pointX;

}


public int GetIndexOfChar (byte c) {





























	 int index = (short)((((int)c) & 0xff) - (((int)mIndexFromCharCode[fieldLowestCharCode]) & 0xff));


	if(index < 0|| index >= (((int)mIndexFromCharCode[fieldCharCodeMapCount]) & 0xff))
		return  (((int)((int)-1)) & 0xff);

	return  (((int)mIndexFromCharCode[fieldCharCodeMap + index]) & 0xff);

}


public byte GetIdenticalChar (byte letter, boolean isLast) {


	 int c = (((int)letter) & 0xff);


	if(c == (((int)(byte)'\n') & 0xff) || c == (((int)(byte)'\r') & 0xff) || c == (((int)(byte)'\u001F') & 0xff) || c == (((int)(byte)'\u001D') & 0xff) || c == 0xFF)
	{
		letter = 0;
	}
	else if(c == (((int)(byte)'\u00A0') & 0xff) || c == (((int)(byte)'\u001E') & 0xff))
	{
		letter = (byte)' ';
	}


	else if(c == (((int)(byte)'\u00AD') & 0xff))
	{
		if(isLast)
		{
			letter = (byte)'-';
		}
		else
		{
			letter = 0;
		}
	}
return  letter;

}


public short[] mIndexFromCharCode = null;
public BitmapMapBlob mBitmapMapBlob;
public byte[] mFontMetrics = null;
public int GetLineWidth(BitmapMap bitmapMap, String string, int start, int iMaxCharCount)
{
	return GetLineWidth(bitmapMap, string, start, iMaxCharCount, true);
}
public int GetLineWidth(BitmapMap bitmapMap, String string, int start, int iMaxCharCount, boolean removeLastAdvance)
{
	return GetLineWidth(bitmapMap, string, start, iMaxCharCount, removeLastAdvance, true);
}
public int GetCharWidth(BitmapMap bitmapMap, byte letter, boolean isFirst, boolean isLast)
{
	return GetCharWidth(bitmapMap, letter, isFirst, isLast, true);
}

/* One dimension array */
public static FlBitmapFontBlob[] InstArrayFlBitmapFontBlob(int size) {
	FlBitmapFontBlob[] newArray = new FlBitmapFontBlob[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlBitmapFontBlob();
	return newArray; }

/* Two dimension array */
public static FlBitmapFontBlob[][] InstArrayFlBitmapFontBlob(int size1, int size2) {
	FlBitmapFontBlob[][] newArray = new FlBitmapFontBlob[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlBitmapFontBlob[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlBitmapFontBlob(); }
	return newArray; }

/* Three dimension array */
public static FlBitmapFontBlob[][][] InstArrayFlBitmapFontBlob(int size1, int size2, int size3) {
	FlBitmapFontBlob[][][] newArray = new FlBitmapFontBlob[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlBitmapFontBlob[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlBitmapFontBlob[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlBitmapFontBlob(); } }
	return newArray; }



}

