package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlMath {

public static int IntegerSqrt (int x) {

	return  0;

}


public static short Random (short a, short b) {


    if(b == a) return  a;
    return  (short)(a + ((Rand(true)) % (b - a + 1))) ;

}


public static int Random (int a, int b) {


    if(b == a) return  a;
    return  (a + ((Rand()) % (b - a + 1)));

}


public static int Rand (boolean returnAsShort) {

     int randomState = FrameworkGlobals.GetInstance().randomState;

     int ret = randomState;


    if(!returnAsShort)
    {
         long tempRandomState = randomState;


        
        tempRandomState = (long)randomState * (long)214013L + (long)2531011L;
        ret = (int)(tempRandomState >> 32) & 0x7fffffff;

        
        FrameworkGlobals.GetInstance().randomState = (int)tempRandomState;


    }
    else
    {
        

        
        randomState = randomState * 214013+ 2531011;
        ret = (randomState >> 16) & 0x7fff;

        
        FrameworkGlobals.GetInstance().randomState = randomState;

        
    }

    return  ret;

}


public static void Seed (int newSeed) {

	FrameworkGlobals.GetInstance().randomState = newSeed;

}


public static int Modulo (int value, int modulo) {



	value %= modulo;
	if(value < 0) value += modulo;

	return  value;

}


public static byte Absolute(byte a) {
 if(a < 0) a = (byte)-a; return  a; 
}


public static short Absolute(short a) {
 if(a < 0) a = (short)-a; return  a; 
}


public static int Absolute(int a) {
 if(a < 0) a = -a; return  a; 
}


public static long Absolute(long a) {
 if(a < 0) a = -a; return  a; 
}


public static F32 Absolute(F32 a) {
 return  a.Abs(); 
}


public static byte Minimum(byte a, byte b) {
 if(a < b) b = a; return  b; 
}


public static short Minimum(short a, short b) {
 if(a < b) b = a; return  b; 
}


public static int Minimum(int a, int b) {
 if(a < b) b = a; return  b; 
}


public static long Minimum(long a, long b) {
 if(a < b) b = a; return  b; 
}


public static F32 Minimum(F32 a, F32 b) {
 return  (a.LessThan(b)) ? a : b; 
}


public static byte Maximum(byte a, byte b) {
 if(a > b) b = a; return  b; 
}


public static short Maximum(short a, short b) {
 if(a > b) b = a; return  b; 
}


public static int Maximum(int a, int b) {
 if(a > b) b = a; return  b; 
}


public static long Maximum(long a, long b) {
 if(a > b) b = a; return  b; 
}


public static F32 Maximum(F32 a, F32 b) {
 return  (a.GreaterThan(b)) ? a : b; 
}


public static boolean IsOdd(int number) {
 return  ((number & 1) == 1); 
}


public static boolean IsEven(int number) {
 return  ((number & 1) == 0); 
}


public static boolean IsPowerOf2(int number) {
 return  ((number & (number - 1)) == 0); 
}


public static int GetPowerOf2(int number) {
 if(!IsPowerOf2(number)) return  -1;
		 int power = 0;

		while((number >> power) != 0) power++;
		return  power - 1;
	
}


public static int GetNextPowerOf2(int number) {
 if(IsPowerOf2(number)) return  number;
		 int power = 0;

		while((number >> power) != 0) power++;
		return  (1<< (power));
	
}


public static float Sqrt (float x) {

	return  0; 

}


public static float ArcTan (float a, float b) {

	return  0;

}


public static float Absolute(float a) {
 return  ((a < 0) ? -a : a); 
}


public static float Minimum(float a, float b) {
 return  (a < b) ? a : b; 
}


public static float Maximum(float a, float b) {
 return  (a > b) ? a : b; 
}


public static float epsilon;
public static float twoPi;
public static float Pi;
public static int Round (float f) {
	
	return  0;

}


public static int Floor (float f) {

	 return  0; 

}


public static int Ceiling (float f) {

	return  0;

}


public static float SubtractFloor (float f) {

	return  f - Floor(f);

}


public static boolean AbnormalValue(double a5) {
 return  false; 
}


public static void CheckForAbnormalValue (double f) {



}


public static float NearExponentialDecay (float x) {


	return  0;

}


public static float GetUniformRandom (float low, float high) {

	

	return  0;

}


public static float GetGaussianRandom (float low, float high) {

	

	return  0;

}


public static int Rand()
{
	return Rand(false);
}
public static float GetUniformRandom()
{
	return GetUniformRandom(0.0f);
}
public static float GetUniformRandom(float low)
{
	return GetUniformRandom(low, 1.0f);
}
public static float GetGaussianRandom()
{
	return GetGaussianRandom(0.0f);
}
public static float GetGaussianRandom(float low)
{
	return GetGaussianRandom(low, 1.0f);
}

/* One dimension array */
public static FlMath[] InstArrayFlMath(int size) {
	FlMath[] newArray = new FlMath[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlMath();
	return newArray; }

/* Two dimension array */
public static FlMath[][] InstArrayFlMath(int size1, int size2) {
	FlMath[][] newArray = new FlMath[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlMath[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlMath(); }
	return newArray; }

/* Three dimension array */
public static FlMath[][][] InstArrayFlMath(int size1, int size2, int size3) {
	FlMath[][][] newArray = new FlMath[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlMath[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlMath[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlMath(); } }
	return newArray; }

public FlMath () { 
}




}

