package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Font {

public static Font Cast(Object o, Font _) {
 return  (Font)o; 
}


 final public static byte typeNumber = TypeIDOfType_Font.v;
 final public static byte typeID = TypeIDOfType_Font.w;
 public static final boolean supportsDynamicSerialization = false; public  Font () {



}


public void destruct() {

	mFontBlob = null;
	mBitmapMap = null;





}


public int GetLineWidth ( String string, int start, int length, boolean removeLastAdvance, boolean isBeginOfString) {



	if(length == 0) 
	{
		return  0;
	}
	return  mFontBlob.GetLineWidth(mBitmapMap, string, start, length, removeLastAdvance, isBeginOfString);

}


public int GetLineWidth(String string, int nChars) {
 return  GetLineWidth(string, 0, nChars); 
}


public int GetLineWidth(String string) {
 return  GetLineWidth(string, 0, string.GetLength()); 
}


public int GetLineHeight () {


	return  mFontBlob.GetLineHeight();

}


public Vector2_short GetLineSize(String string, int startIndex, int nChars)    {
 return  new Vector2_short((short)GetLineWidth(string, startIndex, nChars), (short)GetLineHeight()); 
}


public int GetCharWidth (byte letter, boolean first, boolean last, boolean removeLastAdvance) {



	return  mFontBlob.GetCharWidth(mBitmapMap, letter, first, last, removeLastAdvance);

}


public int GetCharRecede (byte letter, boolean isLast) {




	return  mFontBlob.GetCharRecede(mBitmapMap, letter, isLast);

}


public byte GetLeading () {


	return  mFontBlob.GetLeading();

}


public void SetLeading (byte newLeading) {


	mFontBlob.SetLeading(newLeading);

}


public void SetReferenceBitmap (Bitmap bitmap) {


	mBitmapMap.SetReferenceBitmap(bitmap);	

}


public Bitmap GetReferenceBitmap () {


	return mBitmapMap.GetReferenceBitmap();

}


public boolean ValidateString ( String toValidate) {


	return  mFontBlob.ValidateString(toValidate);	

}


public void OnSerialize (Package p) {






(mFontBlob)= mFontBlob.Cast((p).SerializePointer((mFontBlob).typeNumber, (mFontBlob).supportsDynamicSerialization, false), null);
	(mBitmapMap)= mBitmapMap.Cast((p).SerializePointer((mBitmapMap).typeNumber, (mBitmapMap).supportsDynamicSerialization, false), null);



	if ((mFontBlob instanceof FlBitmapFontBlob))
	{

		mBitmapMap.SetBitmapMapBlob(((FlBitmapFontBlob)mFontBlob).mBitmapMapBlob);


		 short[] matrix = mBitmapMap.mBlob.mDataMatrix;
		 int count = mBitmapMap.GetBitmapCount();

		((FlBitmapFontBlob)mFontBlob).CreateCharCodeMap(matrix, count);
}




}


public void DrawString (DisplayContext displayContext, String string, short pointX, short pointY, short width, int start, int length, short opacity) {












mFontBlob.DrawString(mBitmapMap, displayContext, string, pointX, pointY, start, length, opacity);














}


public FlFontBlob mFontBlob;
public BitmapMap mBitmapMap;
public int GetLineWidth(String string, int start, int nChars)
{
	return GetLineWidth(string, start, nChars, true);
}
public int GetLineWidth(String string, int start, int nChars, boolean removeLastAdvance)
{
	return GetLineWidth(string, start, nChars, removeLastAdvance, true);
}
public Vector2_short GetLineSize(String string)
{
	return GetLineSize(string, (int)0);
}
public Vector2_short GetLineSize(String string, int startIndex)
{
	return GetLineSize(string, startIndex, (int)-1);
}
public int GetCharWidth(byte letter, boolean first, boolean last)
{
	return GetCharWidth(letter, first, last, true);
}
public int GetCharRecede(byte letter)
{
	return GetCharRecede(letter, false);
}

/* One dimension array */
public static Font[] InstArrayFont(int size) {
	Font[] newArray = new Font[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Font();
	return newArray; }

/* Two dimension array */
public static Font[][] InstArrayFont(int size1, int size2) {
	Font[][] newArray = new Font[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Font[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Font(); }
	return newArray; }

/* Three dimension array */
public static Font[][][] InstArrayFont(int size1, int size2, int size3) {
	Font[][][] newArray = new Font[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Font[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Font[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Font(); } }
	return newArray; }



}

