package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class PtrArray_String {

public static PtrArray_String Cast(Object o, PtrArray_String _) {
 return  (PtrArray_String)o; 
}


 final public static byte typeNumber = TypeIDOfType_PtrArray_String.v;
 final public static byte typeID = TypeIDOfType_PtrArray_String.w;
 public static final boolean supportsDynamicSerialization = false; public PtrArray_String() {
 
			
			this(0, 32);
			
		
}


public PtrArray_String(int inCapacity, int inDelta) {
 
			mVector = new java.util.Vector(inCapacity, inDelta);
		
}


public PtrArray_String(PtrArray_String array) {
 	
			
			this(array.GetCapacity(), 32);
			

			 PtrArray_String me = this; 

			
			me.Assign(array);
		
}


public PtrArray_String Assign(PtrArray_String array) {
  java.util.Vector thisVector = mVector;
			 java.util.Vector otherVector = array.mVector;
			 int length = otherVector.size();

			thisVector.setSize(length);
			for(int i = 0;i < length;i ++)
			{
				thisVector.setElementAt(otherVector.elementAt(i), i);
			}
			return  this;
		
}


public void Clear() {
 mVector.removeAllElements();
		
}


public int Find(String element) {
 return  mVector.indexOf(element);
		
}


public int Start() {
 return  0;
		
}


public int End() {
 return  mVector.size();
		
}


public boolean IsEmpty() {
 return  mVector.isEmpty();
		
}


public void SetAt(String element, int p) {

			mVector.setElementAt(element, p);
		
}


public String GetAt(int p) {

			return  (String)mVector.elementAt(p);
		
}


public void Insert(String element) {
 mVector.addElement(element);
		
}


public void InsertAt(String element, int p) {

			mVector.insertElementAt(element, p);
		
}


public void Remove(String element) {
 mVector.removeElement(element);
		
}


public void RemoveAt(int p) {
 mVector.removeElementAt(p);
		
}


public boolean MoveToEnd(String element) {
 mVector.removeElement(element);
			mVector.addElement(element);
			return  true;
		
}


public void EnsureCapacity(int inNewSize) {
 mVector.ensureCapacity(inNewSize);
		
}


public void SetSize(int newSize) {
 mVector.setSize(newSize);
		
}


public int GetCapacity() {
 return  mVector.capacity();
		
}


public void OnSerialize(Package _package) {
 if(_package.IsReading())
			{
				 int count = 0;

				(count)= (_package).SerializeIntrinsic(count);

				Clear();
				EnsureCapacity(count);

				for(int i = 0;i < count;++i)
				{
					 String data = null;
					(data)= data.Cast((_package).SerializePointer((data).typeNumber, (data).supportsDynamicSerialization, false), null);
					Insert(data);
				}
			}
		
}


public java.util.Vector mVector;

/* One dimension array */
public static PtrArray_String[] InstArrayPtrArray_String(int size) {
	PtrArray_String[] newArray = new PtrArray_String[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new PtrArray_String();
	return newArray; }

/* Two dimension array */
public static PtrArray_String[][] InstArrayPtrArray_String(int size1, int size2) {
	PtrArray_String[][] newArray = new PtrArray_String[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PtrArray_String[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new PtrArray_String(); }
	return newArray; }

/* Three dimension array */
public static PtrArray_String[][][] InstArrayPtrArray_String(int size1, int size2, int size3) {
	PtrArray_String[][][] newArray = new PtrArray_String[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PtrArray_String[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new PtrArray_String[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new PtrArray_String(); } }
	return newArray; }



}

