package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class RandomGenerator {

public RandomGenerator (int seed) {

	randomState = seed;

}


public void ReInitialize (int seed) {

	randomState = seed;

}


public short GetUniformShort (short a, short b) {


	if(b == a) return  a;
	return  (short)(a + ((Rand()) % (b - a + 1))) ;

}


public int Rand () {


	randomState = randomState * 214013+ 2531011;


 int ret = (randomState >> 16) & 0x7fff;

	return  ret;

}


public int randomState;
public RandomGenerator()
{
	this((int)0);
}

/* One dimension array */
public static RandomGenerator[] InstArrayRandomGenerator(int size) {
	RandomGenerator[] newArray = new RandomGenerator[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new RandomGenerator();
	return newArray; }

/* Two dimension array */
public static RandomGenerator[][] InstArrayRandomGenerator(int size1, int size2) {
	RandomGenerator[][] newArray = new RandomGenerator[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RandomGenerator[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new RandomGenerator(); }
	return newArray; }

/* Three dimension array */
public static RandomGenerator[][][] InstArrayRandomGenerator(int size1, int size2, int size3) {
	RandomGenerator[][][] newArray = new RandomGenerator[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RandomGenerator[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new RandomGenerator[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new RandomGenerator(); } }
	return newArray; }



}

