package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class RectSide {

public final static byte TOP = 0x1;
public final static byte BOTTOM = 0x2;
public final static byte RIGHT = 0x4;
public final static byte LEFT = 0x8;


/* One dimension array */
public static RectSide[] InstArrayRectSide(int size) {
	RectSide[] newArray = new RectSide[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new RectSide();
	return newArray; }

/* Two dimension array */
public static RectSide[][] InstArrayRectSide(int size1, int size2) {
	RectSide[][] newArray = new RectSide[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RectSide[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new RectSide(); }
	return newArray; }

/* Three dimension array */
public static RectSide[][][] InstArrayRectSide(int size1, int size2, int size3) {
	RectSide[][][] newArray = new RectSide[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RectSide[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new RectSide[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new RectSide(); } }
	return newArray; }

public RectSide () { 
}




}

