package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Sound {

public static Sound Cast(Object o, Sound _) {
 return  (Sound)o; 
}


 final public static byte typeNumber = TypeIDOfType_Sound.v;
 final public static byte typeID = TypeIDOfType_Sound.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Sound () {
mImplementor = new BaseSoundImp();





}


public void destruct() {




}


public BaseSoundImp mImplementor;
public void OnSerialize (Package _package) {
	
	 int tmpSoundFormat = 0;



(tmpSoundFormat)= (_package).SerializeIntrinsic(tmpSoundFormat);
	
	java.lang.String soundFormat = ConvertSoundFormat(tmpSoundFormat);
	

























































{


{











































mImplementor = new BaseSoundImp();
mImplementor.SetSoundFormat(soundFormat);
	mImplementor.OnSerialize(_package);


}
	}

}


public java.lang.String GetSoundFormat () {
	


return  mImplementor.GetSoundFormat();

}


public java.lang.String ConvertSoundFormat (int soundFormat) {


	switch(soundFormat)
	{
		case SoundFormat.Wave : return  "audio/x-wav";
		case SoundFormat.Midi : return  "audio/midi";
		case SoundFormat.Spf : return  "Undefined";
		case SoundFormat.Qcp : return  "audio/vnd.qcelp";
		case SoundFormat.Aac : return  "audio/aac";
		case SoundFormat.Tone : return  "audio/x-tone-seq";
		case SoundFormat.Mmf : return  "application/x-smaf";
		case SoundFormat.Imy : return  "text/x-imelody";
		case SoundFormat.Mp3 : return  "audio/mpeg";
		case SoundFormat.Amr : return  "audio/amr";
		case SoundFormat.Pmd : return  "Undefined";
		case SoundFormat.M4a : return  "Undefined";
		case SoundFormat.Ogg : return  "Undefined";
		default : return  "Undefined";
	}



}



/* One dimension array */
public static Sound[] InstArraySound(int size) {
	Sound[] newArray = new Sound[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Sound();
	return newArray; }

/* Two dimension array */
public static Sound[][] InstArraySound(int size1, int size2) {
	Sound[][] newArray = new Sound[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sound[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Sound(); }
	return newArray; }

/* Three dimension array */
public static Sound[][][] InstArraySound(int size1, int size2, int size3) {
	Sound[][][] newArray = new Sound[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sound[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Sound[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Sound(); } }
	return newArray; }



}

