package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class StringUtils {


		public static String CreateString(java.lang.String javaString)
		{
			





byte[] byteArray = javaString.getBytes();
			String fwkString = new String();
			fwkString.Assign(byteArray, 0, byteArray.length);

			return fwkString;
		}
		
	public static String CreateStringPtr(java.lang.String javaString)
	{
		return CreateString(javaString);
	}
	public static String CreateString ( byte [] string) {

	 String s = new String(string);

	return  s;

}


public static String CreateString (String string) {

	return  string;

}


public static String CreateStringPtr ( byte [] string) {

	return  new String(string);

}


public static String CreateFromANSIString ( byte [] data, int size, int offset) {













String pszStr = new String();

	for(int i = 0;i < size;i ++ )
	{
		pszStr.InsertCharAt(i, (byte)data[offset + i]);
	}
	return  pszStr;

}


public static  byte [] ToRawString ( String string) {

	return  string.ToRawString();

}


public static String StringAdd ( String string1, byte [] string2) {

	return  string1.Add(string2);

}


public static int StringLen ( byte [] data) {

	 int length = 0;


	while(data[length] != 0)
	{
		++length;
	}

	return  length;

}


public static void StringNCopy (byte [] dest, byte [] source, int startInDest, int startInSource, int len) {

	for(int charNum = 0;charNum < len;charNum ++)
	{
		dest[startInDest + charNum] = source[startInSource + charNum];
		if(source[startInSource + charNum] == 0)
		{
			break;
		}
	}

}


public static void StringNCopy (byte [] dest, byte [] source, int len) {

	StringNCopy(dest, source, 0, 0, len);

}


public static void StringCopy (byte [] dest, byte [] source) {

	 int i = 0;

	while((dest[i] = source[i]) != 0)
	{
		i++;
	}

}


public static void StringCat (byte [] dest, byte [] source) {

	StringNCopy(dest, source, StringLen(dest), 0, StringLen(source) + 1);

}


public static void StringCat (String dest, byte [] source) {

	dest.AddAssign(source);

}


public static int StringLong (byte [] dest, int value) {

	 boolean isNegative = false;

	
	if(value < 0)
	{
		isNegative = true;
		value = -value;		
	}

	 int i = String.kBufferSizeForLongValue;

	dest[--i] = (byte)0;

	do
	{
		dest[--i] = (byte)((byte)'0' + (value % 10));
		value /= 10;
	}
	while(value != 0);

	if(isNegative)
	{
		dest[--i] = (byte)'-';
	}
	
	return  i;

}


public static int StringLongLong (byte [] dest, long value) {

	 boolean isNegative = false;


	if(value < 0)
	{
		isNegative = true;
		value = -value;		
	}

	 int i = String.kBufferSizeForLongValue * 2;

	dest[--i] = (byte)0;

	do
	{
		dest[--i] = (byte)((byte)'0' + (value % 10));
		value /= 10;
	}
	while(value != 0);

	if(isNegative)
	{
		dest[--i] = (byte)'-';
	}

	return  i;

}


public static int StringCmp ( byte [] src1, byte [] src2) {

	return  StringNCmp(src1, src2, -1);

}


public static int StringNCmp ( byte [] src1, byte [] src2, int len) {

	


 byte c1 = (byte)'\0';

		 byte c2 = (byte)'\0';

	 int i = 0;


	while((len < 0) || (i < len))
	{
		


c1 = (byte)src1[i];
			c2 = (byte)src2[i];
		if(c1 != c2 || c1 == 0)
		{
			return  c1 - c2;
		}
		i++;
	}

	return  c1 - c2;

}


public static int StringChr ( byte [] string, int start, byte c) {
	
	do 
	{if (string[start] == c){return start;}} while (string[start++] != 0);

	return  -1;	

}


public static int StringRChr ( byte [] string, byte c) {

	 int length = StringLen(string);


	if(length == 0)
	{
		return  0;
	}

	 int p = length - 1;


	do 
	{
		if(string[p] == c)
		{
			return  p;
		}
	}
	while(--p >= 0);

	return  -1;	

}


public static byte [] StringDuplicate ( byte [] str) {


	 byte [] dupstr = new byte[StringLen(str) + 1];


StringCopy(dupstr, str);
	return  dupstr;

}


public static int StringFindSubstring ( byte [] source, byte [] token) {

	return  StringFindSubstring(source, token, 0);

}


public static int StringFindSubstring ( byte [] source, byte [] token, int from) {

	 int a = -1;

	 int b = 0;


	


	if(token[b] == 0)
	{
		return  0;
	}

	if(from != 0&& from >= StringLen(source))
	{
		return  -1;
	}
	
	for(int str = from;source[str] != 0;str += 1)
	{
		if(source[str] != token[b])
		{
			continue;
		}
		a = str;
		while(true) 
		{
			if(token[b] == 0)
			{
				return  str;
			}
			if(source[a++] != token[b++])
			{
				break;
			}
		}
		b = 0;
	}
	return  -1;

}


public static void ChangePathSeparator (byte [] inString) {

	int i;




 byte PlatformSeparator = (byte)'\\';
 
 int size = StringLen(inString);

	for(i = 0;i < size;i ++)
	{
		
		
		if(inString[i] == (byte)'/' ||  inString[i] == (byte)'\\') 
		{
			inString[i] = PlatformSeparator;
		}
	}

}


public static byte ToHexDigit (short n) {

	 String hexDigits = new String(StringUtils.CreateString("0123456789abcdef"));

	return  hexDigits.GetCharAt(n & 0x0f);

}


public static short FromHexDigit (byte c) {

	 String hexDigits = new String(StringUtils.CreateString("0123456789abcdef"));

	return  (short)hexDigits.FindChar(c);

}


public static String EncodeURL ( String url) {

	String encodedURL = new String();

	for(int i = 0;i < url.GetLength();i ++)
	{
		 byte c = url.GetCharAt(i);

		 boolean encode = c <= 0x1f|| c >= 0x7f;

		if(!encode)
		{
			switch(c)
			{
				case '$' : case '&' : case '+' : case ',' : case '/' : case ':' : case ';' : case '=' :
				case '?' : case '@' : case ' ' : case '<' : case '>' : case '#' : case '%' : case '{' :
				case '}' : case '|' : case '\\' : case '^' : case '~' : case '[' : case ']' : case '`' :
					encode = true;
			}
		}
		if(encode)
		{
			encodedURL.InsertCharAt(encodedURL.GetLength(), (byte)('%'));
			encodedURL.InsertCharAt(encodedURL.GetLength(), ToHexDigit((short)((c & 0x00f0) / 16)));
			encodedURL.InsertCharAt(encodedURL.GetLength(), ToHexDigit((short)(c & 0x000f)));
		}
		else
		{
			encodedURL.InsertCharAt(encodedURL.GetLength(), c);
		}
	}

	return  encodedURL;

}


public static String DecodeURL ( String url) {

	String decodedURL = new String();

	for(int i = 0;i < url.GetLength();i ++)
	{
		 byte c = url.GetCharAt(i);

		if(c == '%' && i < url.GetLength() - 3)
		{
			 short value = (short)(FromHexDigit(url.GetCharAt(i + 1)) * 0x10+ FromHexDigit(url.GetCharAt(i + 2)));

			decodedURL.InsertCharAt(decodedURL.GetLength(), (byte)value);
			i += 2;
		}
		else
		{
			decodedURL.InsertCharAt(decodedURL.GetLength(), c);
		}
	}

	return  decodedURL;

}


public static String ToLowerCase ( String string) {

	 String rStr = new String(string);

	 int lgt = rStr.GetLength();

	for(int i = 0;i < lgt;i ++)
	{
		 byte letter = rStr.GetCharAt(i);


		if(letter >= 'A' && letter <= 'Z')
		{
			rStr.ReplaceCharAt(i, (byte)(letter - 'A' + 'a'));
		}
	}
	return  rStr;

}


public static int StringAtoI ( byte [] pString) {


	return  java.lang.Integer.parseInt(StringUtils.CreateJavaString(StringUtils.CreateString(pString)));





}


public static long StringAtoLL ( byte [] pString) {


	return  java.lang.Long.parseLong(StringUtils.CreateJavaString(StringUtils.CreateString(pString)));



}



	public static java.lang.String CreateJavaString(String string)
	{
		return CreateJavaString(string, 0, string.GetLength());
	}

	public static java.lang.String CreateJavaString(String string, int start, int length)
	{
		;
		char[] javaRawString = new char[length];
		
		for (int destI = 0; destI < length; destI++)
		{
			javaRawString[destI] = (char) (string.GetCharAt(start++)

				& 0xFF
);
		}
		return new java.lang.String(javaRawString);
	}

	public static int StringToBytes(java.lang.String str, byte[] dest, int posInDest)
	{
		final int strLen = str.length();
		for (int i = 0; i < strLen; ++i)
		{
			final int c = str.charAt(i);

			dest[posInDest++] = (byte)(c >>> 8);
			dest[posInDest++] = (byte)(c & 0x00ff);
		}

		return posInDest;
	}

	public static String CreateFromANSIString(byte [] data, int size)
{
	return CreateFromANSIString(data, size, (int)0);
}

/* One dimension array */
public static StringUtils[] InstArrayStringUtils(int size) {
	StringUtils[] newArray = new StringUtils[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new StringUtils();
	return newArray; }

/* Two dimension array */
public static StringUtils[][] InstArrayStringUtils(int size1, int size2) {
	StringUtils[][] newArray = new StringUtils[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new StringUtils[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new StringUtils(); }
	return newArray; }

/* Three dimension array */
public static StringUtils[][][] InstArrayStringUtils(int size1, int size2, int size3) {
	StringUtils[][][] newArray = new StringUtils[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new StringUtils[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new StringUtils[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new StringUtils(); } }
	return newArray; }

public StringUtils () { 
}




}

