package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Viewport extends Component {

public static Viewport Cast(Object o, Viewport _) {
 return  (Viewport)o; 
}


 final public static byte typeNumber = TypeIDOfType_Viewport.v;
 final public static byte typeID = TypeIDOfType_Viewport.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Viewport () {
super();
mSubtype = (-1);



}


public  Viewport (Viewport viewport) {
super();
mSubtype = (-1);


	SetViewport(viewport);

}


public void destruct() {

	while(m_pFirstChild != null)
	{
		 Component child = m_pFirstChild;



child.SetViewport(null);
		child = null;
	}

}


public void Term() {
 
}


public void OnDraw (DisplayContext displayContext) {

 short offsetX = (short)(mRect_left - mOffsetX);

	 short offsetY = (short)(mRect_top - mOffsetY);

	displayContext.OffsetBy(offsetX, offsetY);


	if(mClipChildren)
	{
		 short baseClippingRect_left = displayContext.GetClippingRectLeft();
  short baseClippingRect_top = displayContext.GetClippingRectTop();
  short baseClippingRect_width = displayContext.GetClippingRectWidth();
  short baseClippingRect_height = displayContext.GetClippingRectHeight();

 short newClipRect_left = mOffsetX;
  short newClipRect_top = mOffsetY;
  short newClipRect_width = mRect_width;
  short newClipRect_height = mRect_height;
		
		{  int clipperRight = (baseClippingRect_left + baseClippingRect_width);
  int clippedRight = (newClipRect_left + newClipRect_width);
  int clipperBottom = (baseClippingRect_top + baseClippingRect_height);
  int clippedBottom = (newClipRect_top + newClipRect_height);
 if(baseClippingRect_left > newClipRect_left) newClipRect_left = baseClippingRect_left; if(baseClippingRect_top > newClipRect_top) newClipRect_top = baseClippingRect_top; if(clipperRight < clippedRight) clippedRight = clipperRight; if(clipperBottom < clippedBottom) clippedBottom = clipperBottom; newClipRect_width = (short)(clippedRight - newClipRect_left); newClipRect_height = (short)(clippedBottom - newClipRect_top); }

		if(!(newClipRect_width <= 0|| newClipRect_height <= 0))
		{
			displayContext.SetClippingRect(newClipRect_left, newClipRect_top, newClipRect_width, newClipRect_height);
			

DrawChildList(displayContext);

				

displayContext.SetClippingRect(baseClippingRect_left, baseClippingRect_top, baseClippingRect_width, baseClippingRect_height);
		}
	}
	else
{
		

DrawChildList(displayContext);
		    
			

}

	displayContext.OffsetBy((short)-offsetX, (short)-offsetY);




}


public void OffsetTo(Vector2_short offset) {
 OffsetTo(offset.GetX(), offset.GetY()); 
}


public void OffsetBy(Vector2_short offset) {
 OffsetBy(offset.GetX(), offset.GetY()); 
}


public Vector2_short GetOffset() {
 return  new Vector2_short(mOffsetX, mOffsetY); 
}


public Vector2_short GetDelta() {
 return  new Vector2_short(GetDeltaX(), GetDeltaY()); 
}


public void OffsetTo (short inPointX, short inPointY) {

	mOffsetX = inPointX;
	mOffsetY = inPointY;	
	super.Invalidate();

}


public void OffsetBy (short inDeltaX, short inDeltaY) {

	mOffsetX = (short)(mOffsetX + inDeltaX);
	mOffsetY = (short)(mOffsetY + inDeltaY);
	super.Invalidate();

}


public short GetOffsetX() {
 return  mOffsetX; 
}


public short GetOffsetY() {
 return  mOffsetY; 
}


public short GetDeltaX () {

	 short deltaX = (short)0;

	if(m_pViewport != null)
	{
		deltaX = m_pViewport.GetDeltaX();
	}
	return  (short)(deltaX + GetRectLeft() - mOffsetX);

}


public short GetDeltaY () {

	 short deltaY = (short)0;

	if(m_pViewport != null)
	{
		deltaY = m_pViewport.GetDeltaY();
	}
	return  (short)(deltaY + GetRectTop() - mOffsetY);

}


public void GetRequiredOffsetChange (Vector2_short outOffset, Component descendent, boolean bottomright) {

	 int scrollOffsetX = 0;

	 int scrollOffsetY = 0;

	 int totalOffsetX = 0;

	 int totalOffsetY = 0;


	 Viewport viewportToView = descendent.GetViewport();

	while(viewportToView != null && viewportToView != this)
	{
		totalOffsetX += viewportToView.GetRectLeft() - viewportToView.mOffsetX;
		totalOffsetY += viewportToView.GetRectTop() - viewportToView.mOffsetY;

		viewportToView = viewportToView.GetViewport();
	}
	if(viewportToView == null)
	{
		outOffset.SetX((short)0);
		outOffset.SetY((short)0);
		return ;
	}

	 int leftOffset = totalOffsetX + descendent.GetRectLeft() - mOffsetX;

	 int topOffset = totalOffsetY + descendent.GetRectTop() - mOffsetY;

	 int rightOffset = leftOffset + descendent.GetRectWidth() - mRect_width;

	 int bottomOffset = topOffset + descendent.GetRectHeight() - mRect_height;


	
	 boolean isComponentXBigger = (descendent.GetRectWidth() > mRect_width);

	 boolean isComponentYBigger = (descendent.GetRectHeight() > mRect_height);


	{ 

		if(isComponentXBigger)
		{
			scrollOffsetX = bottomright ? rightOffset : leftOffset;
		}
		else
		{
			if(leftOffset < 0)
			{
				scrollOffsetX = leftOffset;
			}
			if(rightOffset > 0)
			{
				scrollOffsetX = rightOffset;
			}
		}
	}

	{ 

		if(isComponentYBigger)
		{
			scrollOffsetY = bottomright ? bottomOffset : topOffset;
		}
		else
		{
			if(topOffset < 0)
			{
				scrollOffsetY = topOffset;
			}
			if(bottomOffset > 0)
			{
				scrollOffsetY = bottomOffset;
			}
		}
	}

	outOffset.SetX((short)scrollOffsetX);
	outOffset.SetY((short)scrollOffsetY);

}


public void ChangeOffsetToShow (Component descendent, boolean bottomright) {

	Vector2_short offsetToScroll = new Vector2_short();

	GetRequiredOffsetChange(offsetToScroll, descendent, bottomright);
	OffsetBy(offsetToScroll.GetX(), offsetToScroll.GetY());

}


public void SetClipChildren(boolean clip) {
 mClipChildren = clip; 
}


public boolean GetClipChildren() {
 return  mClipChildren; 
}


public void SetSubtype(int subtype) {
 mSubtype = (byte)subtype;
	
}


public int GetSubtype() {
 return  mSubtype; 
}


public void OnAttach (boolean attach) {

	super.OnAttach(attach);
	
	 Component child = m_pLastChild;
	while(child != null)
	{
		child.OnAttach(attach);
		child = child.m_pPreviousSibling;
	}
	SendMsg(this, (int)attachMsg, attach ? isAttached : isDetached); 

}


public void OnChildEvent (Component child) {
 
	if(GetViewport() != null)  
	{ 
		GetViewport().OnChildEvent(child); 
	} 

}


public Component GetHitTestComponent (short ptX, short ptY) {

	if(IsVisible() && HitTest(ptX, ptY))
	{
		 short relativePtX = (short)(ptX - GetRectLeft() + GetOffsetX());

		 short relativePtY = (short)(ptY - GetRectTop() + GetOffsetY());

		
		 Component child = m_pFirstChild;

		while(child != null)
		{
			 Component topComponentTouched = child.GetHitTestComponent(relativePtX, relativePtY);

			if(topComponentTouched != null)
			{
				return   topComponentTouched;
			}
			
			child = FindNextSibling(child);
		}

		return  super.GetHitTestComponent(ptX, ptY);
	}
		
	return  null;

}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

    (mOffsetX)= (p).SerializeIntrinsic(mOffsetX);
	(mOffsetY)= (p).SerializeIntrinsic(mOffsetY);
	(mClipChildren)= (p).SerializeIntrinsic(mClipChildren);
	(mSubtype)= (p).SerializeIntrinsic(mSubtype);














{
        int i;

         short nbChilds = 0;

        (nbChilds)= (p).SerializeIntrinsic(nbChilds);
        for(i = 0;i < nbChilds;i ++)
        {
             Component child = null;
            (child)= child.Cast((p).SerializePointer((child).typeNumber, (child).supportsDynamicSerialization, false), null);

            child.SetViewport(this);
        }
    }

}


public boolean mClipChildren;
public void DrawChildList (DisplayContext displayContext) {

	 Component child = m_pLastChild;

	while(child != null)
	{
		if(child.IsVisible())
		{











child.OnDraw(displayContext);
			}
		child = child.m_pPreviousSibling;
	}

}


public short mOffsetX;
public short mOffsetY;
public byte mSubtype;
public Component m_pFirstChild;
public Component m_pLastChild;
public void SendComponentToBack (Component component) {


	if(m_pFirstChild != m_pLastChild)
	{
		RemoveChild(component);

		component.m_pPreviousSibling = m_pLastChild;
		m_pLastChild = component;
	}

}


public void BringComponentToFront (Component component) {


	 Component oldFirstChild = m_pFirstChild;
	if(oldFirstChild != m_pLastChild)
	{
		RemoveChild(component);
		AddChild(component);
	}







}


public void PutComponentBehind (Component from, Component to) {


	if((m_pFirstChild != m_pLastChild) && (from != to))
	{
		RemoveChild(from);

		 Component oldToPreviousSibling = to.m_pPreviousSibling;

		if(oldToPreviousSibling == null)
		{
			m_pFirstChild = from;
		}
		from.m_pPreviousSibling = oldToPreviousSibling;
		to.m_pPreviousSibling = from;
	}

}


public void PutComponentInFront (Component from, Component to) {


	if((m_pFirstChild != m_pLastChild) && (from != to))
	{
		RemoveChild(from);

		 Component oldToNextSibling = FindNextSibling(to);

		from.m_pPreviousSibling = to;
		
		if(oldToNextSibling != null)
		{
			oldToNextSibling.m_pPreviousSibling = from;
		}
		else
		{
			m_pLastChild = from;
		}
	}

}


public short GetChildCount () {

     short nbChilds = 0;

     Component child = m_pLastChild;
    while(child != null)
    {
        nbChilds++;
        child = child.m_pPreviousSibling;
    }
    return  nbChilds;

}


public Component GetChild (int index) {


	
	 Component child = m_pLastChild;
	for(int i = 0;i < index;i ++)
	{
		child = child.m_pPreviousSibling;
	}
	return  child;

}


public void AddChild (Component child) {

	 Component oldFirstChild = m_pFirstChild;
	child.m_pPreviousSibling = null;

	if(oldFirstChild != null)
	{
		oldFirstChild.m_pPreviousSibling = child;
	}
	else
	{
		m_pLastChild = child;
	}
	
	m_pFirstChild = child;
	child.Invalidate();







}


public void RemoveChild (Component childToRemove) {



	 Component previous = childToRemove.m_pPreviousSibling;
	 Component next = FindNextSibling(childToRemove);

	if(previous == null)
	{
		m_pFirstChild = next;
	}

	if(next != null)
	{
		next.m_pPreviousSibling = previous;
	}
	else
	{
		m_pLastChild = previous;
	}

	childToRemove.m_pPreviousSibling = null;
	childToRemove.Invalidate();

}


public Component FindNextSibling (Component child) {

	 Component nextSibling = null;
	 Component currentSibling = m_pLastChild;
	while(currentSibling != null && child != currentSibling)
	{
		nextSibling = currentSibling;
		currentSibling = currentSibling.m_pPreviousSibling;
	}

	return  nextSibling;

}



/* One dimension array */
public static Viewport[] InstArrayViewport(int size) {
	Viewport[] newArray = new Viewport[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Viewport();
	return newArray; }

/* Two dimension array */
public static Viewport[][] InstArrayViewport(int size1, int size2) {
	Viewport[][] newArray = new Viewport[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Viewport[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Viewport(); }
	return newArray; }

/* Three dimension array */
public static Viewport[][][] InstArrayViewport(int size1, int size2, int size3) {
	Viewport[][][] newArray = new Viewport[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Viewport[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Viewport[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Viewport(); } }
	return newArray; }



}

