package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetriminoL extends Tetrimino {

public  TetriminoL (Well pWell) {
super(pWell);


	mMinosX[0] = 0;
	mMinosY[0] = 0;
	mMinosX[1] = 1;
	mMinosY[1] = 0;
	mMinosX[2] = -1;
	mMinosY[2] = 0;
	mMinosX[3] = 1;
	mMinosY[3] = -1;

	









}


public boolean IsFree (int adjX, int adjY, int newFacingDir) {

	 Well well = mpWell;
	 short newX = (short)(mMatrixPosX + adjX);

	 short newY = (short)(mMatrixPosY + adjY);


	switch((int)newFacingDir) 
	{
	case kPieceFaceN :
		if(	newX < 1||
			newX >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1||
			newY > (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsBlockUsed(newX+1, newY-1) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTNorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoJLTNorthSouthMask) ? Constants.tetriminoJLTNorthSouthMask : ConstantsGetter.GetConstants().tetriminoJLTNorthSouthMaskFct()), (newX-1), newY))
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if(	newX < 0||
			newX >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1||
			newY >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsBlockUsed(newX, newY-1) ||
			well.IsBlockUsed(newX, newY) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTEastWestMask == (int)ConstantsEnglishLandscape.tetriminoJLTEastWestMask) ? Constants.tetriminoJLTEastWestMask : ConstantsGetter.GetConstants().tetriminoJLTEastWestMaskFct()), newX, newY+1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if(	newX < 1||
			newX >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1||
			newY >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTNorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoJLTNorthSouthMask) ? Constants.tetriminoJLTNorthSouthMask : ConstantsGetter.GetConstants().tetriminoJLTNorthSouthMaskFct()), (newX-1), newY) ||
			well.IsBlockUsed(newX-1, newY+1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(	newX < 1||
			newX > (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1||
			newY >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTEastWestMask == (int)ConstantsEnglishLandscape.tetriminoJLTEastWestMask) ? Constants.tetriminoJLTEastWestMask : ConstantsGetter.GetConstants().tetriminoJLTEastWestMaskFct()), (newX-1), newY-1) ||
			well.IsBlockUsed(newX, newY) ||
			well.IsBlockUsed(newX, newY+1)) 
		{
			return  false;
		}
		break;
	}
	
	return  true;

}


public boolean CanFall () {
	
	 Well well = mpWell;

	 short x = mMatrixPosX;

	 short y = mMatrixPosY;

	
	switch((int)mFacingDir) 
	{
	case kPieceFaceN :
		if(y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1|| 
			 well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTNorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoJLTNorthSouthMask) ? Constants.tetriminoJLTNorthSouthMask : ConstantsGetter.GetConstants().tetriminoJLTNorthSouthMaskFct()), (x -1), y +1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTEastWestMask == (int)ConstantsEnglishLandscape.tetriminoJLTEastWestMask) ? Constants.tetriminoJLTEastWestMask : ConstantsGetter.GetConstants().tetriminoJLTEastWestMaskFct()), x, y+2)) 
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoJLTNorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoJLTNorthSouthMask) ? Constants.tetriminoJLTNorthSouthMask : ConstantsGetter.GetConstants().tetriminoJLTNorthSouthMaskFct()), (x-1), y+1) ||
			well.IsBlockUsed(x-1, y+2)) 
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsBlockUsed(x-1, y) ||
			well.IsBlockUsed(x, y+2)) 
		{
			return  false;
		}
		break;
	}
	
	return  true;	

}


public int GetType() {
 return  kTetriminoL; 
}


public byte GetMinoColor() {
 return  (byte)(((int)ConstantsEnglishPortrait.minoTypeOrange == (int)ConstantsEnglishLandscape.minoTypeOrange) ? Constants.minoTypeOrange : ConstantsGetter.GetConstants().minoTypeOrangeFct()); 
}





}

