package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetriminoS extends Tetrimino {

public  TetriminoS (Well pWell) {
super(pWell);


	mMinosX[0] = 0;
	mMinosY[0] = 0;
	mMinosX[1] = 0;
	mMinosY[1] = -1;
	mMinosX[2] = -1;
	mMinosY[2] = 0;
	mMinosX[3] = 1;
	mMinosY[3] = -1;

	









}


public boolean IsFree (int adjX, int adjY, int newFacingDir) {

	 Well well = mpWell;
	 short x = (short)(mMatrixPosX + adjX);

	 short y = (short)(mMatrixPosY + adjY);


	switch((int)newFacingDir) 
	{
	case kPieceFaceN :
		if(	x < 1||
			x > (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1-1||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), x, y-1) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), (x-1), y))
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if(	x < 0||
			x > (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1-1||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) -1||
			well.IsBlockUsed(x, y-1) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), x, y) ||
			well.IsBlockUsed(x+1, y+1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if(	x < 1||
			x > (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1-1||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) -1||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), x, y) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), (x-1), y+1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(	x < 1||
			x > (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) -1||
			well.IsBlockUsed(x-1, y-1) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), (x-1), y) ||
			well.IsBlockUsed(x, y+1)) 
		{
			return  false;
		}
		break;
	}
	
	return  true;

}


public boolean CanFall () {
	
	 Well well = mpWell;

	 short x = mMatrixPosX;

	 short y = mMatrixPosY;


	switch((int)mFacingDir) 
	{
	case kPieceFaceN :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsBlockUsed(x+1, y) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), (x-1), y+1)) 
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsBlockUsed(x, y+1) ||
			well.IsBlockUsed(x+1, y+2)) 
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsBlockUsed(x+1, y+1) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoSZMask == (int)ConstantsEnglishLandscape.tetriminoSZMask) ? Constants.tetriminoSZMask : ConstantsGetter.GetConstants().tetriminoSZMaskFct()), (x-1), y+2)) 
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsBlockUsed(x-1, y+1) ||
			well.IsBlockUsed(x, y+2)) 
		{
			return  false;
		}
		break;
	}
	
	return  true;	

}


public int GetType() {
 return  kTetriminoS; 
}


public byte GetMinoColor() {
 return  (byte)(((int)ConstantsEnglishPortrait.minoTypeGreen == (int)ConstantsEnglishLandscape.minoTypeGreen) ? Constants.minoTypeGreen : ConstantsGetter.GetConstants().minoTypeGreenFct()); 
}





}

